#include "Common.h"

//============================================================
// Nbv{[hieLXgj

// eLXgNbv{[hɕۑ
bool SetClipboardText(String^ text) {
	try {
		Clipboard::SetText(text);
		return true;
	} catch (ArgumentNullException^) {
		MessageBox::Show("w肳ꂽeLXgkł");
	}
	return false;
}

// eLXgNbv{[h擾
String^ GetClipboardText() {
	if (Clipboard::ContainsText()) {
		return Clipboard::GetText();
	}
	return nullptr;
}

// eLXgNbv{[hɕۑeXg
void TestSetClipboardText() {
	if (SetClipboardText("Nbv{[hɕۑeLXg")) {
		MessageBox::Show("Nbv{[hւ̕ۑɐ");
	}
}

// eLXgNbv{[h擾eXg
void TestGetClipboardText() {
	String^ text=GetClipboardText();
	if (text) {
		MessageBox::Show(text, "Nbv{[h擾eLXg");
	} else {
		MessageBox::Show("Nbv{[hɂ͎擾łeLXg܂");
	}
}

// ۑE擾Er̃eXg
void TestSetGetCompareClipboardText() {
	String^ text="Nbv{[hɕۑeLXg";
	SetClipboardText(text);
	if (GetClipboardText()->Equals(text)) {
		MessageBox::Show("Nbv{[hւ̕ۑE擾Erɐ");
	} else {
		MessageBox::Show("Nbv{[hւ̕ۑE擾ErɎs");
	}
}

//============================================================
// Nbv{[hieLXgjiWin32j

// eLXgNbv{[hɕۑ
bool SetClipboardTextWin32(WCHAR* text) {
	if (!text) {
		::MessageBox(0, L"w肳ꂽeLXgkł", L"", MB_OK);
		return false;
	}
	if (!OpenClipboard(NULL)) {
		::MessageBox(0, L"Nbv{[hJ܂", L"", MB_OK);
		return false;
	}
	EmptyClipboard();
	int size=(wcslen(text)+1)*sizeof(WCHAR);
	HANDLE handle=GlobalAlloc(GMEM_MOVEABLE, size);
	if (!handle) {
		::MessageBox(0, L"mۂł܂", L"", MB_OK);
		CloseClipboard();
		return false;
	}
	void* buf=GlobalLock(handle);
	if (!buf) {
		::MessageBox(0, L"bNł܂", L"", MB_OK);
		GlobalFree(handle);
		CloseClipboard();
		return false;
	}
	memcpy(buf, text, size);
	GlobalUnlock(handle);
	if (!SetClipboardData(CF_UNICODETEXT, handle)) {
		::MessageBox(0, L"Nbv{[hɏ߂܂", L"", MB_OK);
		GlobalFree(handle);
		CloseClipboard();
		return false;
	}
	CloseClipboard();
	return true;
}

// eLXgNbv{[h擾
WCHAR* GetClipboardTextWin32() {
	if (!IsClipboardFormatAvailable(CF_UNICODETEXT)) {
		::MessageBox(0, L"擾łeLXg܂", L"", MB_OK);
		return NULL;
	}
	if (!OpenClipboard(NULL)) {
		::MessageBox(0, L"Nbv{[hJ܂", L"", MB_OK);
		return NULL;
	}
	HANDLE handle=GetClipboardData(CF_UNICODETEXT);
	if (!handle) {
		::MessageBox(0, L"Nbv{[heLXg擾ł܂", L"", MB_OK);
		CloseClipboard();
		return NULL;
	}
	void* buf=GlobalLock(handle);
	if (!buf) {
		::MessageBox(0, L"bNł܂", L"", MB_OK);
		CloseClipboard();
		return NULL;
	}
	int length=wcslen((WCHAR*)buf)+1;
	WCHAR* result=new WCHAR[length];
	memcpy(result, buf, length*sizeof(WCHAR));
	GlobalUnlock(handle);
	CloseClipboard();
	return result;
}

// eLXgNbv{[hɕۑeXg
void TestSetClipboardTextWin32() {
	if (SetClipboardTextWin32(L"Nbv{[hɕۑeLXg")) {
		::MessageBox(0, L"Nbv{[hւ̕ۑɐ", L"", MB_OK);
	}
}

// eLXgNbv{[h擾eXg
void TestGetClipboardTextWin32() {
	WCHAR* text=GetClipboardTextWin32();
	if (text) {
		::MessageBox(0, text, L"Nbv{[h擾eLXg", MB_OK);
	} else {
		::MessageBox(0, L"Nbv{[hɂ͎擾łeLXg܂", L"", MB_OK);
	}
}

// ۑE擾Er̃eXg
void TestSetGetCompareClipboardTextWin32() {
	WCHAR text[]=L"Nbv{[hɕۑeLXg";
	WCHAR* new_text;
	if (
		SetClipboardTextWin32(text) &&
		(new_text=GetClipboardTextWin32()) &&
		wcscmp(new_text, text)==0
	) {
		::MessageBox(0, L"Nbv{[hւ̕ۑE擾Erɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"Nbv{[hւ̕ۑE擾ErɎs", L"", MB_OK);
	}
}

//============================================================
// K\

// K\ɂ錟
List<String^>^ RegexSearch(String^ text, String^ regex) {
	List<String^>^ list=gcnew List<String^>();
	try {
		Regex^ re=gcnew Regex(regex);
		Match^ match=re->Match(text);
		while (match->Success) {
			list->Add(match->Value);
			match=match->NextMatch();
		}
		return list;
	} catch (ArgumentNullException^) {
		MessageBox::Show("w肳ꂽeLXgkł");
	} catch (ArgumentException^) {
		MessageBox::Show("K\sK؂ł");
	}
	return nullptr;
}

// K\ɂ錟̃eXg
void TestRegexSearch() {
	List<String^>^ list=RegexSearch("apple append appetizer application", "app[a-z]*");
	if (list) {
		String^ message="";
		for each (String^ word in list) message+=word+"\n";
		MessageBox::Show(message, "");
	}
}

// K\ɂu
String^ RegexReplace(String^ text, String^ pattern, String^ replacement) {
	try {
		Regex^ re=gcnew Regex(pattern);
		return re->Replace(text, replacement);
	} catch (ArgumentException^) {
		MessageBox::Show("K\sK؂ł");
	}
	return nullptr;
}

// K\ɂũeXg
void TestRegexReplace() {
	String^ text=RegexReplace("apple banana coconut durian", "([a-z]+)", "<$1>");
	if (text) {
		MessageBox::Show(text, "u");
	}
}

// K\ɂuẼeXg
void TestRegexReplaceSearch() {
	String^ text=RegexReplace("ear bear dear fear pear", "ear", "EAR");
	List<String^>^ list=RegexSearch(text, "[a-z]+EAR");
	if (list) {
		String^ message="";
		for each (String^ word in list) message+=word+"\n";
		MessageBox::Show(message, "");
	}
}

//============================================================
// ڂ̊Ǘ

// ڂ̃NX
public ref class Item {
public:
	String^ Name;
	int Price;
	Item(String^ name, int price) : Name(name), Price(price) {}
	String^ Print() { return Name+" \\"+Price; }
};

// ڃXg̍쐬
List<Item^>^ InitItemList() {
	List<Item^>^ list=gcnew List<Item^>();
	list->Add(gcnew Item("no[K[", 200));
	list->Add(gcnew Item("`[Yo[K[", 230));
	list->Add(gcnew Item("tCh|eg", 140));
	return list;
}

// ڂ̔r
public ref class ItemComparerByName : IComparer<Item^> {
public:
	virtual int Compare(Item^ x, Item^ y) {
		return x->Name->CompareTo(y->Name);
	}
};
public ref class ItemComparerByPrice : IComparer<Item^> {
public:
	virtual int Compare(Item^ x, Item^ y) {
		return x->Price.CompareTo(y->Price);
	}
};

// ڂ̃\[g
void SortItemByName(List<Item^>^ list) {
	list->Sort(gcnew ItemComparerByName());
}
void SortItemByPrice(List<Item^>^ list) {
	list->Sort(gcnew ItemComparerByPrice());
}

// \[g̃eXgP
void TestSortItemByName() {
	List<Item^>^ list=InitItemList();
	SortItemByName(list);
	String^ message;
	for each (Item^ item in list) message+=item->Print()+"\n";
	MessageBox::Show(message);
}

// \[g̃eXgQ
void TestSortItemByPrice() {
	List<Item^>^ list=InitItemList();
	SortItemByPrice(list);
	String^ message;
	for each (Item^ item in list) message+=item->Print()+"\n";
	MessageBox::Show(message);
}

// ڂ̌
Item^ SearchItemByName(List<Item^>^ list, String^ name) {
	int index=list->BinarySearch(gcnew Item(name, 0), gcnew ItemComparerByName());
	if (index>=0) return list[index];
	return nullptr;
}
Item^ SearchItemByPrice(List<Item^>^ list, int price) {
	int index=list->BinarySearch(gcnew Item("", price), gcnew ItemComparerByPrice());
	if (index>=0) return list[index];
	return nullptr;
}

// ̃eXgP
void TestSearchItemByName() {
	List<Item^>^ list=InitItemList();
	SortItemByName(list);
	Item^ item=SearchItemByName(list, "no[K[");
	MessageBox::Show(item->Print());
}

// ̃eXgQ
void TestSearchItemByPrice() {
	List<Item^>^ list=InitItemList();
	SortItemByPrice(list);
	Item^ item=SearchItemByPrice(list, 230);
	MessageBox::Show(item->Print());
}


//============================================================
// AhDEhD

// R}h
public ref class Command abstract {
public:
	virtual Command^ Execute()=0;
};

// ڂ̒ǉ
public ref class AddItemCommand : public Command {
	List<Item^>^ list;
	Item^ item;
public:
	AddItemCommand(List<Item^>^ l, Item^ i) : list(l), item(i) {}
	virtual Command^ Execute() override;
};

// ڂ̍폜
public ref class RemoveItemCommand : public Command {
	List<Item^>^ list;
public:
	RemoveItemCommand(List<Item^>^ l) : list(l) {}
	virtual Command^ Execute() override;
};

Command^ AddItemCommand::Execute() {
	list->Add(item);
	return gcnew RemoveItemCommand(list);
}

Command^ RemoveItemCommand::Execute() {
	Item^ item=list[list->Count-1];
	list->RemoveAt(list->Count-1);
	return gcnew AddItemCommand(list, item);
}

// R}hXg
public ref class CommandBuffer {
	Stack<Command^>^ undo;
	Stack<Command^>^ redo;
public:
	CommandBuffer() {
		undo=gcnew Stack<Command^>();
		redo=gcnew Stack<Command^>();
	}
	void AddItem(List<Item^>^ list, Item^ item) {
		undo->Push((gcnew AddItemCommand(list, item))->Execute());
		redo->Clear();
	}
	void RemoveItem(List<Item^>^ list) {
		undo->Push((gcnew RemoveItemCommand(list))->Execute());
		redo->Clear();
	}
	
	// AhD
	void Undo() {
		if (undo->Count>0) {
			redo->Push(undo->Peek()->Execute());
			undo->Pop();
		}
	}

	// hD
	void Redo() {
		if (redo->Count>0) {
			undo->Push(redo->Peek()->Execute());
			redo->Pop();
		}
	}
};

// AhD̃eXg
void TestUndo() {
	CommandBuffer^ cb=gcnew CommandBuffer();
	List<Item^>^ list=InitItemList();
	Item^ item=gcnew Item("IjIO", 190);
	cb->AddItem(list, item);
	cb->RemoveItem(list);
	cb->Undo();
	if (list[list->Count-1]==item) {
		MessageBox::Show("AhDɐ");
	} else {
		MessageBox::Show("AhDEhDɎs");
	}
}

// hD̃eXg
void TestRedo() {
	CommandBuffer^ cb=gcnew CommandBuffer();
	List<Item^>^ list=InitItemList();
	Item^ item0=gcnew Item("IjIO", 190);
	Item^ item1=gcnew Item("AbvpC", 110);
	cb->AddItem(list, item0);
	cb->AddItem(list, item1);
	cb->RemoveItem(list);
	cb->Undo();
	cb->Redo();
	if (list[list->Count-1]==item0) {
		MessageBox::Show("hDɐ");
	} else {
		MessageBox::Show("AhDEhDɎs");
	}
}

// AhDEhD̃eXg
void TestUndoRedo() {
	CommandBuffer^ cb=gcnew CommandBuffer();
	List<Item^>^ list=InitItemList();
	Item^ item0=gcnew Item("IjIO", 190);
	Item^ item1=gcnew Item("AbvpC", 110);
	Item^ item2=gcnew Item("R[X[v", 160);
	cb->AddItem(list, item0);
	cb->AddItem(list, item1);
	cb->RemoveItem(list);
	cb->RemoveItem(list);
	cb->Undo();
	cb->Undo();
	cb->Redo();
	cb->AddItem(list, item2);
	cb->Undo();
	cb->Undo();
	cb->Redo();
	if (list[list->Count-1]==item0) {
		MessageBox::Show("AhDEhDɐ");
	} else {
		MessageBox::Show("AhDEhDɎs");
	}
}

//============================================================
// ڂ̊ǗiWin32j

// ڂ̃NX
class ItemWin32 {
public:
	WCHAR* Name;
	int Price;
	ItemWin32(WCHAR* name, int price) : Price(price) {
		Name=new WCHAR[wcslen(name)+1];
		wcscpy(Name, name);
	}
	~ItemWin32() {
		delete[] Name;
	}
	void Print(WCHAR* buf) {
		wsprintf(buf, L"%s \\%d", Name, Price);
	}
};

// ڃXg̍쐬
void InitItemListWin32(vector<ItemWin32*>* list) {
	list->push_back(new ItemWin32(L"no[K[", 200));
	list->push_back(new ItemWin32(L"`[Yo[K[", 230));
	list->push_back(new ItemWin32(L"tCh|eg", 140));
}

// \[gp̍ڔr
bool PredicateForSortByNameWin32(ItemWin32* x, ItemWin32* y) {
	return wcscmp(x->Name, y->Name)<0;
}
bool PredicateForSortByPriceWin32(ItemWin32* x, ItemWin32* y) {
	return x->Price<y->Price;
}

// ڂ̃\[g
void SortItemByNameWin32(vector<ItemWin32*>* list) {
	sort(list->begin(), list->end(), PredicateForSortByNameWin32);
}
void SortItemByPriceWin32(vector<ItemWin32*>* list) {
	sort(list->begin(), list->end(), PredicateForSortByPriceWin32);
}

// \[g̃eXgP
void TestSortItemByNameWin32() {
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	SortItemByNameWin32(&list);
	wostringstream ss;
	for (size_t i=0; i<list.size(); i++) {
		WCHAR buf[1000];
		list[i]->Print(buf);
		ss<<buf;
		ss<<endl;
	}
	ss<<ends;
	::MessageBox(0, ss.str().c_str(), L"", MB_OK);
}

// \[g̃eXgQ
void TestSortItemByPriceWin32() {
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	SortItemByPriceWin32(&list);
	wostringstream ss;
	for (size_t i=0; i<list.size(); i++) {
		WCHAR buf[1000];
		list[i]->Print(buf);
		ss<<buf;
		ss<<endl;
	}
	ss<<ends;
	::MessageBox(0, ss.str().c_str(), L"", MB_OK);
}

// ڂ̌
ItemWin32* SearchItemByNameWin32(vector<ItemWin32*> list, WCHAR* name) {
	for (int left=0, right=list.size()-1; left<=right;) {
		int center=(left+right)/2;
		int cmp=wcscmp(name, list[center]->Name);
		if (cmp==0) return list[center]; else
		if (cmp<0) right=center-1; else left=center+1;
	}
	return NULL;
}
ItemWin32* SearchItemByPriceWin32(vector<ItemWin32*> list, int price) {
	for (int left=0, right=list.size()-1; left<=right;) {
		int center=(left+right)/2;
		int cmp=price-list[center]->Price;
		if (cmp==0) return list[center]; else
		if (cmp<0) right=center-1; else left=center+1;
	}
	return NULL;
}

// ̃eXgP
void TestSearchItemByNameWin32() {
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	SortItemByNameWin32(&list);
	ItemWin32* item=SearchItemByNameWin32(list, L"no[K[");
	if (item) {
		WCHAR buf[1000];
		item->Print(buf);
		::MessageBox(0, buf, L"", MB_OK);
	} else {
		::MessageBox(0, L"ڂ܂", L"", MB_OK);
	}
}

// ̃eXgQ
void TestSearchItemByPriceWin32() {
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	SortItemByPriceWin32(&list);
	ItemWin32* item=SearchItemByPriceWin32(list, 230);
	if (item) {
		WCHAR buf[1000];
		item->Print(buf);
		::MessageBox(0, buf, L"", MB_OK);
	} else {
		::MessageBox(0, L"ڂ܂", L"", MB_OK);
	}
}


//============================================================
// AhDEhDiWin32j

// R}h
class CommandWin32 {
public:
	virtual CommandWin32* Execute()=0;
};

// ڂ̒ǉ
class AddItemCommandWin32 : public CommandWin32 {
	vector<ItemWin32*>* list;
	ItemWin32* item;
public:
	AddItemCommandWin32(vector<ItemWin32*>* l, ItemWin32* i) : list(l), item(i) {}
	virtual CommandWin32* Execute();
};

// ڂ̍폜
class RemoveItemCommandWin32 : public CommandWin32 {
	vector<ItemWin32*>* list;
public:
	RemoveItemCommandWin32(vector<ItemWin32*>* l) : list(l) {}
	virtual CommandWin32* Execute();
};

CommandWin32* AddItemCommandWin32::Execute() {
	list->push_back(item);
	return new RemoveItemCommandWin32(list);
}

CommandWin32* RemoveItemCommandWin32::Execute() {
	ItemWin32* item=list->back();
	list->pop_back();
	return new AddItemCommandWin32(list, item);
}

// R}hXg
class CommandBufferWin32 {
	stack<CommandWin32*> undo;
	stack<CommandWin32*> redo;
public:
	CommandBufferWin32() {}
	void AddItem(vector<ItemWin32*>* list, ItemWin32* item) {
		undo.push((new AddItemCommandWin32(list, item))->Execute());
		while (!redo.empty()) redo.pop();
	}
	void RemoveItem(vector<ItemWin32*>* list) {
		undo.push((new RemoveItemCommandWin32(list))->Execute());
		while (!redo.empty()) redo.pop();
	}
	
	// AhD
	void Undo() {
		if (!undo.empty()) {
			redo.push(undo.top()->Execute());
			undo.pop();
		}
	}

	// hD
	void Redo() {
		if (!redo.empty()) {
			undo.push(redo.top()->Execute());
			redo.pop();
		}
	}
};

// AhD̃eXg
void TestUndoWin32() {
	CommandBufferWin32* cb=new CommandBufferWin32();
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	ItemWin32* item=new ItemWin32(L"IjIO", 190);
	cb->AddItem(&list, item);
	cb->RemoveItem(&list);
	cb->Undo();
	if (list.back()==item) {
		::MessageBox(0, L"AhDɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"AhDɎs", L"", MB_OK);
	}
}

// hD̃eXg
void TestRedoWin32() {
	CommandBufferWin32* cb=new CommandBufferWin32();
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	ItemWin32* item0=new ItemWin32(L"IjIO", 190);
	ItemWin32* item1=new ItemWin32(L"AbvpC", 110);
	cb->AddItem(&list, item0);
	cb->AddItem(&list, item1);
	cb->RemoveItem(&list);
	cb->Undo();
	cb->Redo();
	if (list.back()==item0) {
		::MessageBox(0, L"hDɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"hDɎs", L"", MB_OK);
	}
}

// AhDEhD̃eXg
void TestUndoRedoWin32() {
	CommandBufferWin32* cb=new CommandBufferWin32();
	vector<ItemWin32*> list;
	InitItemListWin32(&list);
	ItemWin32* item0=new ItemWin32(L"IjIO", 190);
	ItemWin32* item1=new ItemWin32(L"AbvpC", 110);
	ItemWin32* item2=new ItemWin32(L"R[X[v", 160);
	cb->AddItem(&list, item0);
	cb->AddItem(&list, item1);
	cb->RemoveItem(&list);
	cb->RemoveItem(&list);
	cb->Undo();
	cb->Undo();
	cb->Redo();
	cb->AddItem(&list, item2);
	cb->Undo();
	cb->Undo();
	cb->Redo();
	if (list.back()==item0) {
		::MessageBox(0, L"AhDEhDɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"AhDEhDɎs", L"", MB_OK);
	}
}

//============================================================
// rbg

// 񋓌^iWin32j
enum BitEnum {
	NONE=0, BOLD=1, ITALIC=2, UNDERLINE=4
};

// 񋓌^̃eXgiWin32j
void TestBitEnum() {
	int bits=BOLD|ITALIC;
	if ((bits&BOLD) && (bits&ITALIC)) {
		MessageBox::Show("񋓌^̃eXgɐ");
	}
}

// CLI񋓌^
[Flags]
enum struct BitFlags {
	None=0, Bold=1, Italic=2, Underline=4
};

// CLI񋓌^̃eXg
void TestBitFlags() {
	BitFlags bits=BitFlags::Bold|BitFlags::Italic;
	if ((bits&BitFlags::Bold)!=BitFlags::None && (bits&BitFlags::Italic)!=BitFlags::None) {
		MessageBox::Show("CLI񋓌^̃eXgɐ");
	}
}

// rbgtB[h
struct BitField {
	unsigned Bold:1;
	unsigned Italic:1;
	unsigned Underline:1;
};

// rbgtB[h̃eXg
void TestBitField() {
	BitField bits;
	bits.Bold=1;
	bits.Italic=1;
	if (bits.Bold && bits.Italic) {
		MessageBox::Show("rbgtB[h̃eXgɐ");
	}
}

//============================================================
// RNV

// z
void TestArray() {
	array<int>^ a=gcnew array<int>(100);
	for (int i=0; i<a->Length; i++) {
		a[i]=i;
	}
	int sum=0;
	for each (int i in a) {
		sum+=i;
	}
	if (sum==4950) {
		MessageBox::Show("z̃eXgɐ");
	}
}

// ziWin32j
void TestArrayWin32() {
	int a[100];
	for (int i=0; i<sizeof(a)/sizeof(int); i++) {
		a[i]=i;
	}
	int sum=0;
	for (int i=0; i<sizeof(a)/sizeof(int); i++) {
		sum+=a[i];
	}
	if (sum==4950) {
		::MessageBox(0, L"z̃eXgɐ", L"", MB_OK);
	}
}

// ϒz
void TestDynamicArray() {
	List<int>^ l=gcnew List<int>();
	for (int i=0; i<100; i++) {
		l->Add(i);
	}
	int sum=0;
	for each (int i in l) {
		sum+=i;
	}
	if (sum==4950) {
		MessageBox::Show("ϒz̃eXgɐ");
	}
}

// ϒziWin32j
void TestDynamicArrayWin32() {
	vector<int> v;
	for (int i=0; i<100; i++) {
		v.push_back(i);
	}
	int sum=0;
	for (size_t i=0; i<v.size(); i++) {
		sum+=v[i];
	}
	if (sum==4950) {
		::MessageBox(0, L"ϒz̃eXgɐ", L"", MB_OK);
	}
}

// X^bN
void TestStack() {
	Stack<int>^ s=gcnew Stack<int>();
	for (int i=0; i<100; i++) {
		s->Push(i);
	}
	int sum=0;
	while (s->Count>0) {
		sum+=s->Pop();
	}
	if (sum==4950) {
		MessageBox::Show("X^bÑeXgɐ");
	}
}

// X^bNiWin32j
void TestStackWin32() {
	stack<int> s;
	for (int i=0; i<100; i++) {
		s.push(i);
	}
	int sum=0;
	while (!s.empty()) {
		sum+=s.top();
		s.pop();
	}
	if (sum==4950) {
		::MessageBox(0, L"X^bÑeXgɐ", L"", MB_OK);
	}
}

// z
void TestMultidimensionalArray() {
	array<int, 2>^ a=gcnew array<int, 2>(10, 10);
	for (int i=0; i<a->GetLength(0); i++) {
		for (int j=0; j<a->GetLength(1); j++) {
			a[i,j]=j;
		}
	}
	int sum=0;
	for each (int i in a) {
		sum+=i;
	}
	if (sum==450) {
		MessageBox::Show("z̃eXgɐ");
	}
}

// ziWin32j
void TestMultidimensionalArrayWin32() {
	int a[10][10];
	for (int i=0; i<sizeof(a)/sizeof(a[0]); i++) {
		for (int j=0; j<sizeof(a[0])/sizeof(int); j++) {
			a[i][j]=j;
		}
	}		
	int sum=0;
	for (int i=0; i<sizeof(a)/sizeof(a[0]); i++) {
		for (int j=0; j<sizeof(a[0])/sizeof(int); j++) {
			sum+=a[i][j];
		}
	}
	if (sum==450) {
		::MessageBox(0, L"z̃eXgɐ", L"", MB_OK);
	}
}

// WOz
void TestJagArray() {
	array<array<int>^>^ a=gcnew array<array<int>^>(10);
	for (int i=0; i<a->Length; i++) {
		a[i]=gcnew array<int>(i+1);
		for (int j=0; j<a[i]->Length; j++) {
			a[i][j]=j;
		}
	}
	int sum=0;
	for each (array<int>^ b in a) {
		for each (int i in b) {
			sum+=i;
		}
	}
	if (sum==165) {
		MessageBox::Show("WOz̃eXgɐ");
	}
}

// WOziWin32j
void TestJagArrayWin32() {
	int* a[10];
	for (int i=0; i<sizeof(a)/sizeof(int*); i++) {
		a[i]=new int[i+1];
		for (int j=0; j<i+1; j++) {
			a[i][j]=j;
		}
	}
	int sum=0;
	for (int i=0; i<sizeof(a)/sizeof(int*); i++) {
		for (int j=0; j<i+1; j++) {
			sum+=a[i][j];
		}
		delete[] a[i];
	}
	if (sum==165) {
		::MessageBox(0, L"WOz̃eXgɐ", L"", MB_OK);
	}
}

