#include "Common.h"

//============================================================
// oCit@C

// 
array<unsigned char>^ ReadBinaryFile(String^ file) {
	FileStream^ fs;
	try {
		fs=gcnew FileStream(file, FileMode::Open);
		if (fs->Length>0x7fffffff) throw gcnew OutOfMemoryException();
		array<unsigned char>^ data=gcnew array<unsigned char>((int)fs->Length);
		if (!data) throw gcnew OutOfMemoryException();
		fs->Read(data, 0, data->Length);
		return data;
	} catch (FileNotFoundException^) {
		MessageBox::Show("t@C܂", file);
	} catch (OutOfMemoryException^) {
		MessageBox::Show("t@Cǂݍނ߂ɏ\ȃ܂", file);
	} catch (SystemException^) {
		MessageBox::Show("t@C̓ǂݍ݃G[", file);
	} finally {
		if (fs) fs->Close();
	}
	return nullptr;
}

// o
bool WriteBinaryFile(String^ file, array<unsigned char>^ data) {
	FileStream^ fs;
	try {
		fs=gcnew FileStream(file, FileMode::Create);
		fs->Write(data, 0, data->Length);
		return true;
	} catch (SystemException^) {
		MessageBox::Show("t@C̏݃G[");
	} finally {
		if (fs) fs->Close();
	}
	return false;
}

// ̓eXg
void TestReadBinaryFile() {
	array<unsigned char>^ data=ReadBinaryFile("test.bin");
	if (data) MessageBox::Show(data->Length+"oCg̃f[^ǂݍ݂܂");
}

// o̓eXg
void TestWriteBinaryFile() {
	array<unsigned char>^ data=gcnew array<unsigned char>(123);
	if (WriteBinaryFile("test.bin", data)) MessageBox::Show(data->Length+"oCg̃f[^݂܂");
}

// óÉEreXg
void TestWriteReadCompareBinaryFile() {
	array<unsigned char>^ old_data=gcnew array<unsigned char>(123);
	array<unsigned char>^ new_data;
	if (
		WriteBinaryFile("test.bin", old_data) &&
		(new_data=ReadBinaryFile("test.bin")) &&
		new_data->Length==old_data->Length
	) {
		int i;
		for (i=0; i<new_data->Length; i++) {
			if (new_data[i]!=old_data[i]) break;
		}
		if (i==new_data->Length) {
			MessageBox::Show("oCȉóÉErɐ");
			return;
		}
	}
	MessageBox::Show("oCȉóÉErɎs");
}

//============================================================
// oCit@CiWin32j

// ́iWin32j
bool ReadBinaryFileWin32(WCHAR* file, char** data, int* size) {
	HANDLE handle=CreateFile(
		file, GENERIC_READ, FILE_SHARE_READ, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (handle==INVALID_HANDLE_VALUE) {
		::MessageBox(0, L"t@CJ܂", file, MB_OK);
		return false;
	}
	DWORD high_size;
	*size=GetFileSize(handle, &high_size);
	if (!high_size) *data=new char[(DWORD)*size];
	if (high_size || !data) {
		::MessageBox(0, L"t@Cǂݍނ߂ɏ\ȃ܂", file, MB_OK);
		CloseHandle(handle);
		return false;
	}
	DWORD nbytes;
	if (!ReadFile(handle, *data, *size, &nbytes, NULL) || *size!=nbytes) {
		::MessageBox(0, L"t@C̓ǂݍ݃G[", file, MB_OK);
		CloseHandle(handle);
		return false;
	}
	CloseHandle(handle);
	return true;
}

// óiWin32j
bool WriteBinaryFileWin32(WCHAR* file, char* data, int size) {
	HANDLE handle=CreateFile(
		file, GENERIC_WRITE, 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (handle==INVALID_HANDLE_VALUE) {	
		::MessageBox(0, L"t@C쐬ł܂", file, MB_OK);
		return false;
	}
	DWORD nbytes;
	if (!WriteFile(handle, data, size, &nbytes, NULL) || size!=nbytes) {
		::MessageBox(0, L"t@C̏݃G[", file, MB_OK);
		CloseHandle(handle);
		return false;
	}
	CloseHandle(handle);
	return true;
}

// ̓eXgiWin32j
void TestReadBinaryFileWin32() {
	char* data=NULL;
	int size;
	if (ReadBinaryFileWin32(L"test.bin", &data, &size)) {
		WCHAR s[100];
		swprintf_s(s, 100, L"%doCg̃f[^ǂݍ݂܂", size);
		::MessageBox(0, s, L"", MB_OK);
	}
	if (data) delete[] data;
}

// o̓eXgiWin32j
void TestWriteBinaryFileWin32() {
	int size=123;
	char* data=new char[size];
	if (WriteBinaryFileWin32(L"test.bin", data, size)) {
		WCHAR s[100];
		swprintf_s(s, 100, L"%doCg̃f[^݂܂", size);
		::MessageBox(0, s, L"", MB_OK);
	}
	delete[] data;
}

// óÉEreXg
void TestWriteReadCompareBinaryFileWin32() {
	int old_size=123;
	char* old_data=new char[old_size];
	int new_size;
	char* new_data=NULL;
	bool result=false;
	if (
		WriteBinaryFileWin32(L"test.bin", old_data, old_size) &&
		ReadBinaryFileWin32(L"test.bin", &new_data, &new_size) &&
		new_size==old_size
	) {
		int i;
		for (i=0; i<new_size; i++) {
			if (new_data[i]!=old_data[i]) break;
		}
		if (i==new_size) result=true;
	}
	if (result) {
		::MessageBox(0, L"oCȉóÉErɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"oCȉóÉErɎs", L"", MB_OK);
	}
	delete[] old_data;
	if (new_data) delete[] new_data;
}

//============================================================
// eLXgt@C

// 
String^ ReadTextFile(String^ file, String^ encoding) {
	StreamReader^ sr;
	try {
		Encoding^ enc=Encoding::GetEncoding(encoding);
		sr=gcnew StreamReader(gcnew FileStream(file, FileMode::Open), enc);
		return sr->ReadToEnd();
	} catch (ArgumentException^) {
		MessageBox::Show("GR[fBO̎w肪sK؂ł", encoding);
	} catch (FileNotFoundException^) {
		MessageBox::Show("t@C܂", file);
	} catch (OutOfMemoryException^) {
		MessageBox::Show("t@Cǂݍނ߂ɏ\ȃ܂", file);
	} catch (SystemException^) {
		MessageBox::Show("t@C̓ǂݍݒɃG[܂", file);
	} finally {
		if (sr) sr->Close();
	}
	return nullptr;
}

// o
bool WriteTextFile(String^ file, String^ encoding, String^ text) {
	StreamWriter^ sw;
	try {
		Encoding^ enc=Encoding::GetEncoding(encoding);
		sw=gcnew StreamWriter(gcnew FileStream(file, FileMode::Create), enc);
		sw->Write(text);
		return true;
	} catch (ArgumentException^) {
		MessageBox::Show("GR[fBO̎w肪sK؂ł", encoding);
	} catch (SystemException^) {
		MessageBox::Show("t@C̏ݒɃG[܂", file);
	} finally {
		if (sw) sw->Close();
	}
	return false;
}

// ̓eXg
void TestReadTextFile() {
	String^ text=ReadTextFile("test.txt", "shift_jis");
	if (text) MessageBox::Show("eLXg̓͂ɐ");
}

// o̓eXg
void TestWriteTextFile() {
	String^ text="\neXg\nłB";
	if (WriteTextFile("test.txt", "shift_jis", text)) {
		MessageBox::Show("eLXg̏o͂ɐ");
	}
}

// óÉEreXg
void TestWriteReadCompareTextFile() {
	String^ old_text="\neXg\nłB";
	String^ new_text;
	if (
		WriteTextFile("test.txt", "shift_jis", old_text) &&
		(new_text=ReadTextFile("test.txt", "shift_jis")) &&
		new_text->Equals(old_text)
	) {
		MessageBox::Show("eLXg̏óÉErɐ");
	} else {
		MessageBox::Show("eLXg̏óÉErɎs");
	}
}

//============================================================
// eLXgt@CiWin32j

// 
WCHAR* ReadTextFileWin32(WCHAR* file, int encoding) {
	char* data=NULL;
	int size;
	if (ReadBinaryFileWin32(file, &data, &size)) {
		int wsize=MultiByteToWideChar(encoding, 0, data, size, NULL, 0);
		if (wsize>0) {
			WCHAR* text=new WCHAR[wsize];
			if (MultiByteToWideChar(encoding, 0, data, size, text, wsize)==wsize) {
				return text;
			}
		}
		::MessageBox(0, L"GR[fBO̕ϊɎs܂", L"", MB_OK);
	}
	return NULL;
}

// o
bool WriteTextFileWin32(WCHAR* file, int encoding, WCHAR* text) {
	int size=WideCharToMultiByte(encoding, 0, text, -1, NULL, 0, NULL, NULL);
	if (size>0) {
		char* data=new char[size];
		if (WideCharToMultiByte(encoding, 0, text, -1, data, size, NULL, NULL)==size) {
			return WriteBinaryFileWin32(file, data, size);
		}
	}
	::MessageBox(0, L"GR[fBO̕ϊɎs܂", L"", MB_OK);
	return false;
}

// ̓eXg
void TestReadTextFileWin32() {
	WCHAR* text=ReadTextFileWin32(L"test.txt", 932);
	if (text) {
		::MessageBox(0, L"eLXg̓͂ɐ", L"", MB_OK);
	}
}

// o̓eXg
void TestWriteTextFileWin32() {
	WCHAR* text=L"\neXg\nłB";
	if (WriteTextFileWin32(L"test.txt", 932, text)) {
		::MessageBox(0, L"eLXg̏o͂ɐ", L"", MB_OK);
	}
}

// óÉEreXg
void TestWriteReadCompareTextFileWin32() {
	WCHAR* old_text=L"\neXg\nłB";
	WCHAR* new_text;
	if (
		WriteTextFileWin32(L"test.txt", 932, old_text) &&
		(new_text=ReadTextFileWin32(L"test.txt", 932)) &&
		wcscmp(old_text, new_text)==0
	) {
		::MessageBox(0, L"eLXg̏óÉErɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"eLXg̏óÉErɎs", L"", MB_OK);
	}
}

//============================================================
// CSVt@C

// 
array<array<String^>^>^ ReadCSVFile(String^ file, String^ encoding) {
	StreamReader^ sr;
	try {
		Encoding^ enc=Encoding::GetEncoding(encoding);
		sr=gcnew StreamReader(gcnew FileStream(file, FileMode::Open), enc);
		String^ text=sr->ReadToEnd();
		array<String^>^ line=text->Split(gcnew array<String^> {"\r\n", "\r", "\n"}, StringSplitOptions::RemoveEmptyEntries);
		array<array<String^>^>^ table=gcnew array<array<String^>^>(line->Length);
		for (int i=0; i<line->Length; i++) {
			table[i]=line[i]->Split(',');
		}
		return table;
	} catch (ArgumentException^) {
		MessageBox::Show("GR[fBO̎w肪sK؂ł", encoding);
	} catch (FileNotFoundException^) {
		MessageBox::Show("t@C܂", file);
	} catch (OutOfMemoryException^) {
		MessageBox::Show("t@Cǂݍނ߂ɏ\ȃ܂", file);
	} catch (SystemException^) {
		MessageBox::Show("t@C̓ǂݍݒɃG[܂", file);
	} finally {
		if (sr) sr->Close();
	}
	return nullptr;
}

// o
bool WriteCSVFile(String^ file, String^ encoding, array<array<String^>^>^ table) {
	StreamWriter^ sw;
	try {
		Encoding^ enc=Encoding::GetEncoding(encoding);
		sw=gcnew StreamWriter(gcnew FileStream(file, FileMode::Create), enc);
		for each (array<String^>^ row in table) {
			int i;
			for (i=0; i<row->Length-1; i++) {
				sw->Write(row[i]);
				sw->Write(",");
			}
			sw->Write(row[i]);
			sw->WriteLine();
		}
		return true;
	} catch (ArgumentException^) {
		MessageBox::Show("GR[fBO̎w肪sK؂ł", encoding);
	} catch (SystemException^) {
		MessageBox::Show("t@C̏ݒɃG[܂");
	} finally {
		if (sw) sw->Close();
	}
	return false;
}

// eXgf[^̍쐬
array<array<String^>^>^ InitCSVTestData() {
	array<array<String^>^>^ table=gcnew array<array<String^>^>(3);
	table[0]=gcnew array<String^> {"s", "", "aJ", "150-0000"};
	table[1]=gcnew array<String^> {"_ސ쌧", "ls", "", "220-0000"};
	table[2]=gcnew array<String^> {"t", "qs", "", "285-0000"};
	return table;
}

// ̓eXg
void TestReadCSVFile() {
	if (ReadCSVFile("test.csv", "shift_jis")) {
		MessageBox::Show("CSVt@Cǂݍ݂܂");
	}
}

// o̓eXg
void TestWriteCSVFile() {
	if (WriteCSVFile("test.csv", "shift_jis", InitCSVTestData())) {
		MessageBox::Show("CSVt@C݂܂");
	}
}

// óÉEreXg
void TestWriteReadCompareCSVFile() {
	array<array<String^>^>^ old_table=InitCSVTestData();
	array<array<String^>^>^ new_table;
	if (
		WriteCSVFile("test.csv", "shift_jis", old_table) &&
		(new_table=ReadCSVFile("test.csv", "shift_jis")) &&
		new_table->Length==old_table->Length
	) {
		int i;
		for (i=0; i<new_table->Length; i++) {
			if (new_table[i]->Length!=old_table[i]->Length) break;
			for (int j=0; j<new_table[i]->Length; j++) {
				if (!new_table[i][j]->Equals(old_table[i][j])) break;
			}
		}
		if (i==new_table->Length) {
			MessageBox::Show("CSVt@C̏óÉErɐ");
			return;
		}
	}
	MessageBox::Show("CSVt@C̏óÉErɎs");
}

//============================================================
// CSVt@CiWin32j

// 
bool ReadCSVFileWin32(WCHAR* file, int encoding, vector<vector<WCHAR*>>* table) {
	WCHAR* text=ReadTextFileWin32(file, encoding);
	if (!text) return false;
	WCHAR *p, *c;
	if (p=wcstok_s(text, L"\r\n", &c)) {
		do {
			vector<WCHAR*> row;
			for (WCHAR *q=p;;) {
				while (*q!=L'\0' && *q!=L',') q++;
				if (*q==L'\0') {
					row.push_back(p);
					break;
				} else {
					*q++=L'\0';
					row.push_back(p);
					p=q;
				}
			}
			table->push_back(row);
			p=wcstok_s(NULL, L"\r\n", &c);
		} while (p);
	}
	return true;
}

// óiWin32j
bool WriteCSVFileWin32(WCHAR* file, int encoding, vector<vector<WCHAR*>> table) {
	wostringstream ss;
	size_t i, j;
	vector<WCHAR*> row;
	for (i=0; i<table.size(); i++) {
		row=table[i];
		for (j=0; j<row.size()-1; j++) {
			ss<<row[j]<<L',';
		}
		ss<<row[j]<<endl;
	}
	ss<<ends;
	return WriteTextFileWin32(file, encoding, (WCHAR*)ss.str().c_str());
}

// eXgf[^̍쐬
vector<vector<WCHAR*>> InitCSVTestDataWin32() {
	WCHAR* item[3][4]={
		{L"s", L"", L"aJ", L"150-0000"},
		{L"_ސ쌧", L"ls", L"", L"220-0000"},
		{L"t", L"qs", L"", L"285-0000"}
	};
	vector<vector<WCHAR*>> table;
	for (int i=0; i<3; i++) {
		vector<WCHAR*> row;
		for (int j=0; j<4; j++) {
			row.push_back(item[i][j]);
		}
		table.push_back(row);
	}
	return table;
}

// ̓eXg
void TestReadCSVFileWin32() {
	vector<vector<WCHAR*>> table;
	if (ReadCSVFileWin32(L"test.csv", 932, &table)) {
		::MessageBox(0, L"CSVt@Cǂݍ݂܂", L"", MB_OK);
	}
}

// o̓eXg
void TestWriteCSVFileWin32() {
	if (WriteCSVFileWin32(L"test.csv", 932, InitCSVTestDataWin32())) {
		::MessageBox(0, L"CSVt@C݂܂", L"", MB_OK);
	}
}

// óÉEreXg
void TestWriteReadCompareCSVFileWin32() {
	vector<vector<WCHAR*>> old_table=InitCSVTestDataWin32();
	vector<vector<WCHAR*>> new_table;
	if (
		WriteCSVFileWin32(L"test.csv", 932, old_table) &&
		ReadCSVFileWin32(L"test.csv", 932, &new_table) &&
		new_table.size()==old_table.size()
	) {
		size_t i;
		for (i=0; i<new_table.size(); i++) {
			if (new_table[i].size()!=old_table[i].size()) break;
			for (size_t j=0; j<new_table[i].size(); j++) {
				if (wcscmp(new_table[i][j], old_table[i][j])!=0) break;
			}
		}
		if (i==new_table.size()) {
			::MessageBox(0, L"CSVt@C̏óÉErɐ", L"", MB_OK);
			return;
		}
	}
	::MessageBox(0, L"CSVt@C̏óÉErɎs", L"", MB_OK);
}

//============================================================
// GR[fBOʁEϊ

#include <mlang.h>

// ʂ̃Tu[`
int DetectEncoding(CHAR* data, int size) {
	int result=-1;
	CoInitialize(NULL);
	IMultiLanguage3 *ml;
	if (
		CoCreateInstance(
			__uuidof(CMultiLanguage),
			NULL, 
			CLSCTX_INPROC_SERVER, 
			__uuidof(IMultiLanguage3), 
			(void**)&ml
		)==S_OK
	) {
		int detectEncCount=1;
		DetectEncodingInfo detectEnc;
		ZeroMemory(&detectEnc, sizeof(DetectEncodingInfo));
		if (
			ml->DetectInputCodepage(
				MLDETECTCP_8BIT, 0,
				data, &size, 
				&detectEnc,
				&detectEncCount
			)==S_OK
		) {
			result=detectEnc.nCodePage;
		}
		ml->Release();
	}
	CoUninitialize();
	return result;
}

// 
String^ DetectEncoding(String^ file) {
	array<unsigned char>^ data=ReadBinaryFile(file);
	if (data) {
		CHAR* buf=new CHAR[data->Length];
		for (int i=0; i<data->Length; i++) buf[i]=data[i];
		int codepage=DetectEncoding(buf, data->Length);
		delete[] buf;
		try {
			return Encoding::GetEncoding(codepage)->WebName;
		} catch (SystemException^) {
			MessageBox::Show("GR[fBOʂł܂");
		}
	}
	return nullptr;
}

// GR[fBOeXgf[^̍쐬
void InitEncodingTestData() {
	String^ text=
		"͕GR[fBOʁEϊp̃eXgf[^łB\n"
		"GR[fBO̔ʂ𐳂s߂ɂ́A\n"
		"͕̐ނxKv܂B\n";
	for (int i=0; i<3; i++) text+=text;
	WriteTextFile("encoding.txt", "shift_jis", text);
}

// ʃeXg
void TestDetectEncoding() {
	InitEncodingTestData();
	String^ encoding=DetectEncoding("encoding.txt");
	if (encoding) {
		MessageBox::Show("encoding.txt̕GR[fBO"+encoding);
	}
}

// ϊ
bool ConvertEncoding(String^ in_file, String^ out_file, String^ out_encoding) {
	String^ in_encoding=DetectEncoding(in_file);
	if (in_encoding) {
		String^ text=ReadTextFile(in_file, in_encoding);
		if (text) {
			return WriteTextFile(out_file, out_encoding, text);
		}
	}
	return false;
}

// ϊeXg
void TestConvertEncoding() {
	InitEncodingTestData();
	if (
		ConvertEncoding("encoding.txt", "encoding.sjis", "shift_jis") &&
		ConvertEncoding("encoding.txt", "encoding.jis", "iso-2022-jp") &&
		ConvertEncoding("encoding.txt", "encoding.euc", "euc-jp") &&
		ConvertEncoding("encoding.txt", "encoding.utf8", "utf-8")
	) {
		MessageBox::Show("encoding.sjis/jis/euc/utf8o͂܂");
	}
}

// ϊEʁEreXg
void TestConvertDetectCompareEncoding() {
	InitEncodingTestData();
	if (
		!ConvertEncoding("encoding.txt", "encoding.jis", "iso-2022-jp") ||
		!ConvertEncoding("encoding.jis", "encoding.euc", "euc-jp") ||
		!ConvertEncoding("encoding.euc", "encoding.utf8", "utf-8") ||
		!ConvertEncoding("encoding.utf8", "encoding.sjis", "shift_jis")
	) {
		MessageBox::Show("ϊɎs܂");
		return;
	}
	if (
		!DetectEncoding("encoding.jis")->Equals("iso-2022-jp") ||
		!DetectEncoding("encoding.euc")->Equals("euc-jp") ||
		!DetectEncoding("encoding.utf8")->Equals("utf-8") ||
		!DetectEncoding("encoding.sjis")->Equals("shift_jis")
	) {
		MessageBox::Show("ʂɎs܂");
		return;
	}
	String^ old_text=ReadTextFile("encoding.txt", DetectEncoding("encoding.txt"));
	String^ new_text=ReadTextFile("encoding.sjis", DetectEncoding("encoding.sjis"));
	if (!old_text->Equals(new_text)) {
		MessageBox::Show("rɎs܂");
		return;
	}
	MessageBox::Show("GR[fBO̕ϊEʁErɐ܂");		
}

//============================================================
// GR[fBOʁEϊiWin32j

// 
int DetectEncodingWin32(WCHAR* file) {
	int codepage=-1;
	char* data;
	int size;
	if (ReadBinaryFileWin32(file, &data, &size)) {
		codepage=DetectEncoding(data, size);
		delete[] data;
		if (codepage<0) {
			::MessageBox(0, L"GR[fBOʂł܂", L"", MB_OK);
		}
		if (codepage==51932) codepage=20932;
	}
	return codepage;
}

// GR[fBOeXgf[^̍쐬
void InitEncodingTestDataWin32() {
	wstring text=
		L"͕GR[fBOʁEϊp̃eXgf[^łB\n"
		L"GR[fBO̔ʂ𐳂s߂ɂ́A\n"
		L"͕̐ނxKv܂B\n";
	for (int i=0; i<3; i++) text+=text;
	WriteTextFileWin32(L"encoding.txt", 932, (WCHAR*)text.c_str());
}

// ʃeXg
void TestDetectEncodingWin32() {
	InitEncodingTestDataWin32();
	int encoding=DetectEncodingWin32(L"encoding.txt");
	if (encoding>=0) {
		WCHAR buf[1000];
		wsprintf(buf, L"encoding.txt̕GR[fBOiR[hy[Wj%d", encoding);
		::MessageBox(0, buf, L"", MB_OK);
	}
}

// ϊ
bool ConvertEncodingWin32(WCHAR* in_file, WCHAR* out_file, int out_encoding) {
	int in_encoding=DetectEncodingWin32(in_file);
	if (in_encoding>=0) {
		WCHAR* text=ReadTextFileWin32(in_file, in_encoding);
		if (text) {
			return WriteTextFileWin32(out_file, out_encoding, text);
		}
	}
	return false;
}

// ϊeXg
void TestConvertEncodingWin32() {
	InitEncodingTestDataWin32();
	if (
		ConvertEncodingWin32(L"encoding.txt", L"encoding.sjis", 932) &&
		ConvertEncodingWin32(L"encoding.txt", L"encoding.jis", 50220) &&
		ConvertEncodingWin32(L"encoding.txt", L"encoding.euc", 20932) &&
		ConvertEncodingWin32(L"encoding.txt", L"encoding.utf8", 65001)
	) {
		::MessageBox(0, L"encoding.sjis/jis/euc/utf8o͂܂", L"", MB_OK);
	}
}

// ϊEʁEreXg
void TestConvertDetectCompareEncodingWin32() {
	InitEncodingTestDataWin32();
	if (
		!ConvertEncodingWin32(L"encoding.txt", L"encoding.jis", 50220) ||
		!ConvertEncodingWin32(L"encoding.jis", L"encoding.euc", 20932) ||
		!ConvertEncodingWin32(L"encoding.euc", L"encoding.utf8", 65001) ||
		!ConvertEncodingWin32(L"encoding.utf8", L"encoding.sjis", 932)
	) {
		::MessageBox(0, L"ϊɎs܂", L"", MB_OK);
		return;
	}
	if (
		DetectEncodingWin32(L"encoding.jis")!=50220 ||
		DetectEncodingWin32(L"encoding.euc")!=20932 ||
		DetectEncodingWin32(L"encoding.utf8")!=65001 ||
		DetectEncodingWin32(L"encoding.sjis")!=932
	) {
		::MessageBox(0, L"ʂɎs܂", L"", MB_OK);
		return;
	}
	WCHAR* old_text=ReadTextFileWin32(L"encoding.txt", DetectEncodingWin32(L"encoding.txt"));
	WCHAR* new_text=ReadTextFileWin32(L"encoding.sjis", DetectEncodingWin32(L"encoding.sjis"));
	if (wcscmp(old_text, new_text)!=0) {
		::MessageBox(0, L"rɎs܂", L"", MB_OK);
		return;
	}
	::MessageBox(0, L"GR[fBO̕ϊEʁErɐ܂", L"", MB_OK);
}

//============================================================
// XMLt@C

// eXgp̃NX
public ref class XMLItem {
public:
	String^ Name;
	int Price;
	XMLItem() : Name(""), Price(0) {}
	XMLItem(String^ name, int price) : Name(name), Price(price) {}
};

// eXgf[^̍쐬
array<XMLItem^>^ InitXMLTestData() {
	array<XMLItem^>^ data=gcnew array<XMLItem^>(3);
	data[0]=gcnew XMLItem("", 100);
	data[1]=gcnew XMLItem("݂", 80);
	data[2]=gcnew XMLItem("oii", 60);
	return data;
}

// o
bool WriteXMLFile(String^ file, array<XMLItem^>^ data) {
	FileStream^ fs;
	try {
		XmlSerializer^ serializer=gcnew XmlSerializer(array<XMLItem^>::typeid);	
		fs=gcnew FileStream(file, FileMode::Create);
		serializer->Serialize(fs, data);
		return true;
	} catch (SystemException^) {
		MessageBox::Show("t@C̏o͒ɃG[܂", file);
	} finally {
		if (fs) fs->Close();
	}
	return false;
}

// 
array<XMLItem^>^ ReadXMLFile(String^ file) {
	FileStream^ fs;
	try {
		XmlSerializer^ serializer=gcnew XmlSerializer(array<XMLItem^>::typeid);
		fs=gcnew FileStream(file, FileMode::Open);
		array<XMLItem^>^ data=dynamic_cast<array<XMLItem^>^>(serializer->Deserialize(fs));
		return data;
	} catch (FileNotFoundException^) {
		MessageBox::Show("t@C܂", file);
	} catch (SystemException^) {
		MessageBox::Show("t@C̓͒ɃG[܂", file);
	} finally {
		if (fs) fs->Close();
	}
	return nullptr;
}

// o̓eXg
void TestWriteXMLFile() {
	if (WriteXMLFile("test.xml", InitXMLTestData())) {
		MessageBox::Show("XMLt@C̏o͂ɐ");
	}
}

// ̓eXg
void TestReadXMLFile() {
	array<XMLItem^>^ data=ReadXMLFile("test.xml");
	if (data) {
		MessageBox::Show("XMLt@C̓͂ɐ");
	}
}

// óÉEreXg
void TestWriteReadCompareXMLFile() {
	array<XMLItem^>^ old_data=InitXMLTestData();
	array<XMLItem^>^ new_data;
	if (
		WriteXMLFile("test.xml", old_data) &&
		(new_data=ReadXMLFile("test.xml")) &&
		old_data->Length==new_data->Length
	) {
		int i;
		for (i=0; i<old_data->Length; i++) {
			if (
				!old_data[i]->Name->Equals(new_data[i]->Name) ||
				old_data[i]->Price!=new_data[i]->Price
			) {
				break;
			}
		}
		if (i==old_data->Length) {
			MessageBox::Show("XMLt@C̏óÉErɐ");
			return;
		}
	}
	MessageBox::Show("XMLt@C̏óÉErɎs");
}

//============================================================
// t@C

// 
array<String^>^ FindFiles(String^ path, String^ pattern, bool sub_directories) {
	try {
		return Directory::GetFiles(path, pattern, sub_directories?SearchOption::AllDirectories:SearchOption::TopDirectoryOnly);
	} catch (DirectoryNotFoundException^) {
		MessageBox::Show("w肳ꂽpX܂");
	} catch (PathTooLongException^) {
		MessageBox::Show("pX̕񂪒܂");
	} catch (UnauthorizedAccessException^) {
		MessageBox::Show("ANZX֎~Ă܂");
	} catch (ArgumentException^) {
		MessageBox::Show("w肳ꂽpXł");
	} catch (IOException^) {
		MessageBox::Show("w肳ꂽpX̓fBNgł͂Ȃt@Cł");
	}
	return nullptr;
}

// eXg
void TestFindFiles() {
	array<String^>^ files=FindFiles(".", "*", true);
	if (files) {
		String^ message="t@CF\n";
		for each (String^ file in files) message+=file+"\n";
		MessageBox::Show(message);
	}
}

// OύX
bool SetFileName(String^ path, String^ new_name) {
	try {
		File::Move(path, Path::Combine(Path::GetDirectoryName(path), new_name));
		return true;
	} catch (FileNotFoundException^) {
		MessageBox::Show("w肳ꂽt@C܂");
	} catch (DirectoryNotFoundException^) {
		MessageBox::Show("w肳ꂽfBNg܂");
	} catch (PathTooLongException^) {
		MessageBox::Show("pX̕񂪒܂");
	} catch (UnauthorizedAccessException^) {
		MessageBox::Show("ANZX֎~Ă܂");
	} catch (ArgumentException^) {
		MessageBox::Show("w肳ꂽpXł");
	} catch (IOException^) {
		MessageBox::Show("VÕt@Cɑ݂Ă܂");
	}
	return false;
}

// OύXeXg
void TestSetFileName() {
	if (
		SetFileName("file\\oldname.txt", "newname.txt") &&
		SetFileName("file\\newname.txt", "oldname.txt")
	) {
		MessageBox::Show("O̕ύXɐ");
	}
}

// gqύX
bool SetFileExtension(String^ path, String^ new_extension) {
	try {
		String^ new_name=Path::ChangeExtension(Path::GetFileName(path), new_extension);
		if (SetFileName(path, new_name)) return true;
	} catch (ArgumentException^) {
		MessageBox::Show("pXɖȕ܂܂Ă܂");
	}
	return false;
}

// gqύXeXg
void TestSetFileExtension() {
	if (
		SetFileExtension("file\\oldname.txt", ".doc") &&
		SetFileExtension("file\\oldname.doc", ".txt")
	) {
		MessageBox::Show("gq̕ύXɐ");
	}
}

// 擾
int GetFileReadOnly(String^ path) {
	try {
		FileAttributes fa=File::GetAttributes(path);
		if ((fa&FileAttributes::ReadOnly)==FileAttributes::ReadOnly) {
			return 1;
		} else {
			return 0;
		}
	} catch (FileNotFoundException^) {
		MessageBox::Show("w肳ꂽt@C܂");
	} catch (DirectoryNotFoundException^) {
		MessageBox::Show("w肳ꂽfBNg܂");
	} catch (PathTooLongException^) {
		MessageBox::Show("pX̕񂪒܂");
	} catch (ArgumentException^) {
		MessageBox::Show("w肳ꂽpXł");
	} catch (NotSupportedException^) {
		MessageBox::Show("pX̌`ł");
	}
	return -1;
}

// ύX
bool SetFileReadOnly(String^ path, bool read_only) {
	try {
		FileAttributes fa=File::GetAttributes(path);
		if (read_only) {
			File::SetAttributes(path, fa|FileAttributes::ReadOnly);
		} else {
			File::SetAttributes(path, fa&~FileAttributes::ReadOnly);
		}
		return true;
	} catch (FileNotFoundException^) {
		MessageBox::Show("w肳ꂽt@C܂");
	} catch (DirectoryNotFoundException^) {
		MessageBox::Show("w肳ꂽfBNg܂");
	} catch (PathTooLongException^) {
		MessageBox::Show("pX̕񂪒܂");
	} catch (ArgumentException^) {
		MessageBox::Show("w肳ꂽpXł");
	} catch (NotSupportedException^) {
		MessageBox::Show("pX̌`ł");
	} catch (UnauthorizedAccessException^) {
		MessageBox::Show("ANZX֎~Ă܂");
	}
	return false;
}

// 擾eXg
void TestGetFileReadOnly() {
	switch (GetFileReadOnly("file\\readonly.txt")) {
		case 1: 
			MessageBox::Show("t@C͓ǂݎpł"); 
			break;
		case 0: 
			MessageBox::Show("t@C͓ǂݎpł͂܂"); 
			break;
	}
}

// ύXeXg
void TestSetFileReadOnly() {
	if (SetFileReadOnly("file\\readonly.txt", true)) {
		MessageBox::Show("̕ύXɐ");
	}
}

// ύXE擾eXg
void TestSetGetFileReadOnly() {
	String^ path="file\\readonly.txt";
	if (
		SetFileReadOnly(path, false) &&
		GetFileReadOnly(path)==0 &&
		SetFileReadOnly(path, true) &&
		GetFileReadOnly(path)==1
	) {
		MessageBox::Show("̕ύXE擾ɐ");
	}
}

// gqꊇύXeXg
void TestSetMultipleFilesExtension() {
	bool result=true;
	array<String^>^ files;
	if (files=FindFiles("file", "*.txt", true)) {
		for each (String^ file in files) {
			result=result&&SetFileReadOnly(file, false);
			result=result&&SetFileExtension(file, ".doc");
		}
	}
	if (files=FindFiles("file", "*.doc", true)) {
		for each (String^ file in files) {
			result=result&&SetFileExtension(file, ".txt");
		}
	}
	if (result) {
		MessageBox::Show("gq̈ꊇύXɐ");
	} else {
		MessageBox::Show("gq̈ꊇύXɎs");
	}
}

//============================================================
// t@CiWin32j

// 
bool FindFilesWin32(WCHAR* path, WCHAR* pattern, bool sub_directories, vector<WCHAR*>* files) {
	WIN32_FIND_DATA fd;
	if (wcslen(path)+wcslen(pattern)+2>=MAX_PATH) {
		::MessageBox(0, L"pX̕񂪒܂", L"", MB_OK);
		return false;
	}
	WCHAR buf[MAX_PATH];
	wsprintf(buf, L"%s\\%s", path, pattern);
	HANDLE handle=FindFirstFile(buf, &fd);
	if (handle==INVALID_HANDLE_VALUE) {
		::MessageBox(0, L"w肳ꂽpX܂", L"", MB_OK);
		return false;
	}
	do {
		if (wcscmp(fd.cFileName, L".")==0 || wcscmp(fd.cFileName, L"..")==0) continue;
		if (fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) {
			if (sub_directories) {
				WCHAR buf[MAX_PATH];
				wsprintf(buf, L"%s\\%s", path, fd.cFileName);
				FindFilesWin32(buf, pattern, sub_directories, files);
			}
		} else {
			WCHAR* buf=new WCHAR[wcslen(path)+wcslen(fd.cFileName)+2];
			wsprintf(buf, L"%s\\%s", path, fd.cFileName);
			files->push_back(buf);
		}
	} while (FindNextFile(handle, &fd));
	FindClose(handle);
	return true;
}

// eXg
void TestFindFilesWin32() {
	vector<WCHAR*> files;
	if (FindFilesWin32(L".", L"*", true, &files)) {
		wostringstream ss;
		ss<<L"t@CF"<<endl;
		for (size_t i=0; i<files.size(); i++) {
			ss<<files[i]<<endl;
		}
		ss<<ends;
		::MessageBox(0, ss.str().c_str(), L"", MB_OK);
	}
}

// OύX
bool SetFileNameWin32(WCHAR* path, WCHAR* new_name) {
	WCHAR* p=wcsrchr(path, L'\\');
	WCHAR buf[MAX_PATH];
	if (p) {
		wcsncpy(buf, path, p-path+1);
		buf[p-path+1]=L'\0';
	} else {
		buf[0]=L'\0';
	}
	if (wcslen(buf)+wcslen(new_name)>=MAX_PATH) {
		::MessageBox(0, L"pX̕񂪒܂", L"", MB_OK);
		return false;
	}
	wcscat(buf, new_name);
	if (!MoveFile(path, buf)) {
		::MessageBox(0, L"O̕ύXɎs", L"", MB_OK);
		return false;
	}
	return true;
}

// OύXeXg
void TestSetFileNameWin32() {
	if (
		SetFileNameWin32(L"file\\oldname.txt", L"newname.txt") &&
		SetFileNameWin32(L"file\\newname.txt", L"oldname.txt")
	) {
		::MessageBox(0, L"O̕ύXɐ", L"", MB_OK);
	}
}

// gqύX
bool SetFileExtensionWin32(WCHAR* path, WCHAR* new_extension) {
	if (wcslen(path)+wcslen(new_extension)>=MAX_PATH) {
		::MessageBox(0, L"pX̕񂪒܂", L"", MB_OK);
		return false;
	}
	WCHAR* p=wcsrchr(path, L'.');
	WCHAR* q=wcsrchr(path, L'\\');
	WCHAR buf[MAX_PATH];
	if (p && (!q || p>q)) {
		wcsncpy(buf, path, p-path);
		buf[p-path]=L'\0';
	} else {
		wcscpy(buf, path);
	}
	wcscat(buf, new_extension);
	if (!MoveFile(path, buf)) {
		::MessageBox(0, L"O̕ύXɎs", L"", MB_OK);
		return false;
	}
	return true;
}

// gqύXeXg
void TestSetFileExtensionWin32() {
	if (
		SetFileExtensionWin32(L"file\\oldname.txt", L".doc") &&
		SetFileExtensionWin32(L"file\\oldname.doc", L".txt")
	) {
		::MessageBox(0, L"gq̕ύXɐ", L"", MB_OK);
	}
}

// 擾
int GetFileReadOnlyWin32(WCHAR* path) {
	DWORD fa=GetFileAttributes(path);
	if (fa==INVALID_FILE_ATTRIBUTES) {
		::MessageBox(0, L"w肳ꂽt@C܂", L"", MB_OK);
		return -1;
	}
	return (fa&FILE_ATTRIBUTE_READONLY)?1:0;
}

// ύX
bool SetFileReadOnlyWin32(WCHAR* path, bool read_only) {
	DWORD fa=GetFileAttributes(path);
	if (fa==INVALID_FILE_ATTRIBUTES) {
		::MessageBox(0, L"w肳ꂽt@C܂", L"", MB_OK);
		return false;
	}
	if (read_only) {
		fa|=FILE_ATTRIBUTE_READONLY;
	} else {
		fa&=~FILE_ATTRIBUTE_READONLY;
	}
	if (!SetFileAttributes(path, fa)) {
		::MessageBox(0, L"̕ύXɎs", L"", MB_OK);
		return false;
	}
	return true;
}

// 擾eXg
void TestGetFileReadOnlyWin32() {
	switch (GetFileReadOnlyWin32(L"file\\readonly.txt")) {
		case 1: 
			::MessageBox(0, L"t@C͓ǂݎpł", L"", MB_OK); 
			break;
		case 0: 
			::MessageBox(0, L"t@C͓ǂݎpł͂܂", L"", MB_OK); 
			break;
	}
}

// ύXeXg
void TestSetFileReadOnlyWin32() {
	if (SetFileReadOnlyWin32(L"file\\readonly.txt", true)) {
		::MessageBox(0, L"̕ύXɐ", L"", MB_OK);
	}
}

// ύXE擾eXg
void TestSetGetFileReadOnlyWin32() {
	WCHAR* path=L"file\\readonly.txt";
	if (
		SetFileReadOnlyWin32(path, false) &&
		GetFileReadOnlyWin32(path)==0 &&
		SetFileReadOnlyWin32(path, true) &&
		GetFileReadOnlyWin32(path)==1
	) {
		::MessageBox(0, L"̕ύXE擾ɐ", L"", MB_OK);
	}
}

// gqꊇύXeXg
void TestSetMultipleFilesExtensionWin32() {
	bool result=true;
	vector<WCHAR*> files;
	if (FindFilesWin32(L"file", L"*.txt", true, &files)) {
		for (size_t i=0; i<files.size(); i++) { 
			result=result&&SetFileReadOnlyWin32(files[i], false);
			result=result&&SetFileExtensionWin32(files[i], L".doc");
		}
	}
	files.clear();
	if (FindFilesWin32(L"file", L"*.doc", true, &files)) {
		for (size_t i=0; i<files.size(); i++) { 
			result=result&&SetFileExtensionWin32(files[i], L".txt");
		}
	}
	if (result) {
		::MessageBox(0, L"gq̈ꊇύXɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"gq̈ꊇύXɎs", L"", MB_OK);
	}
}

//============================================================
// ÍE

// L[̍쐬
void SetKey(DES^ des, String^ key) {
	array<unsigned char>^ old_key=Encoding::ASCII->GetBytes(key);
	array<unsigned char>^ new_key=gcnew array<unsigned char>(des->Key->Length);
	for (int i=0; i<new_key->Length; i++) {
		new_key[i]=(i<old_key->Length)?old_key[i]:'\0';
	}
	des->Key=new_key;
	des->IV=new_key;
}

// Í
bool EncryptFile(String^ infile, String^ outfile, String^ key) {
	array<unsigned char>^ data=ReadBinaryFile(infile);
	if (!data) {
		MessageBox::Show("̓t@Cǂݍ߂܂");
		return false;
	}
	try {
		DES^ des=gcnew DESCryptoServiceProvider();
		SetKey(des, key);
		CryptoStream^ cs=gcnew CryptoStream(
			gcnew FileStream(outfile, FileMode::Create), 
			des->CreateEncryptor(), 
			CryptoStreamMode::Write);
		cs->Write(data, 0, data->Length);
		cs->Close();
		return true;
	} catch (CryptographicException^) {
		MessageBox::Show("ÍɎs܂");
	}
	return false;
}

// 
bool DecryptFile(String^ infile, String^ outfile, String^ key) {
	array<unsigned char>^ data=ReadBinaryFile(infile);
	if (!data) {
		MessageBox::Show("̓t@Cǂݍ߂܂");
		return false;
	}
	try {
		DES^ des=gcnew DESCryptoServiceProvider();
		SetKey(des, key);
		CryptoStream^ cs=gcnew CryptoStream(
			gcnew FileStream(outfile, FileMode::Create), 
			des->CreateDecryptor(),
			CryptoStreamMode::Write);
		cs->Write(data, 0, data->Length);
		cs->Close();
		return true;
	} catch (CryptographicException^) {
		MessageBox::Show("ɎsiL[Ⴄ\܂j");
	}
	return false;
}

// Í̃eXg
void TestEncryptFile() {
	if (EncryptFile("test.txt", "encrypted.txt", "higpenworks")) {
		MessageBox::Show("Íɐ");
	}
}

// ̃eXg
void TestDecryptFile() {
	if (DecryptFile("encrypted.txt", "decrypted.txt", "higpenworks")) {
		MessageBox::Show("ɐ");
	}
}

// ÍEEr̃eXg
void TestEncryptDecryptCompareFile() {
	array<unsigned char>^ old_data;
	array<unsigned char>^ new_data;
	if (
		(old_data=ReadBinaryFile("test.txt")) &&
		EncryptFile("test.txt", "encrypted.txt", "higpenworks") &&
		DecryptFile("encrypted.txt", "decrypted.txt", "higpenworks") &&
		(new_data=ReadBinaryFile("decrypted.txt")) &&
		old_data->Length==new_data->Length
	) {
		int i;
		for (i=0; i<new_data->Length; i++) {
			if (new_data[i]!=old_data[i]) break;
		}
		if (i==new_data->Length) {
			MessageBox::Show("ÍEErɐ");
			return;
		}
	}
	MessageBox::Show("ÍEErɎs");
}

//============================================================
// t@C̈kE

// k
bool CompressFile(array<String^>^ infile, String^ outfile) {
	array<signed char>^ buf=gcnew array<signed char>(1000);
	java::util::zip::ZipOutputStream^ zos;
	java::io::FileInputStream^ fis;
	try {
		zos=gcnew java::util::zip::ZipOutputStream(
			gcnew java::io::FileOutputStream(outfile));
		String^ file;
		try {
			for each (file in infile) {
				java::util::zip::ZipEntry^ ze=gcnew java::util::zip::ZipEntry(file);
				ze->setMethod(java::util::zip::ZipEntry::DEFLATED);
				zos->putNextEntry(ze);
				fis=gcnew java::io::FileInputStream(file);
				int len;
				while ((len=fis->read(buf))>0) {
					zos->write(buf, 0, len);
				}
				zos->closeEntry();
			}
			return true;
		} catch(java::io::FileNotFoundException^) {
			MessageBox::Show("t@CJ܂", file);
		} catch(java::io::IOException^) {
			MessageBox::Show("o̓G[", file);
		}
	} catch (java::io::FileNotFoundException^) {
		MessageBox::Show("t@CJ܂", outfile);
	} finally {
		if (zos) zos->close();
		if (fis) fis->close();
	}
	return false;
}

// k̃eXg
void TestCompressFile() {
	array<String^>^ infile={
		"test.txt", "test.bmp", "test.jpg", "test.png",
		"file\\oldname.txt", "file\\readonly.txt"
	};
	if (CompressFile(infile, "test.zip")) {
		MessageBox::Show("kɐ");
	}
}

// 
bool DecompressFile(String^ infile, String^ outdir) {
	array<signed char>^ buf=gcnew array<signed char>(1000);
	java::util::zip::ZipInputStream^ zis;
	java::io::FileOutputStream^ fos;
	try {
		zis=gcnew java::util::zip::ZipInputStream(
			gcnew java::io::FileInputStream(infile));
		java::util::zip::ZipEntry^ ze;
		try {
			while (ze=zis->getNextEntry()) {
				if (!ze->isDirectory()) {
					String^ dir=Path::Combine(outdir, Path::GetDirectoryName(ze->getName()));
					Directory::CreateDirectory(dir);
					String^ file=Path::Combine(dir, Path::GetFileName(ze->getName()));
					fos=gcnew java::io::FileOutputStream(file);
					int len;
					while ((len=zis->read(buf))>0) {
						fos->write(buf, 0, len);
					}
				}
			}
			return true;
		} catch (java::io::FileNotFoundException^) {
			MessageBox::Show("t@CJ܂", ze->getName());
		} catch(java::io::IOException^) {
			MessageBox::Show("o̓G[", ze->getName());
		}
	} catch (java::io::FileNotFoundException^) {
		MessageBox::Show("t@CJ܂", infile);
	} finally {
		if (zis) zis->close();
		if (fos) fos->close();
	}
	return false;
}

// 𓀂̃eXg
void TestDecompressFile() {
	if (DecompressFile("test.zip", "zip")) {
		MessageBox::Show("𓀂ɐ");
	}
}

