#include "Common.h"

//============================================================
// ڑ

// HTTP
#define HTTP_URI L"http://???"

// FTP
#define FTP_USER L"???"
#define FTP_PASSWORD L"???"
#define FTP_URI L"ftp://???"
#define FTP_HOST L"???"

// SMTP
#define SMTP_HOST L"???"
#define SMTP_PORT 587
#define SMTP_USER L"???"
#define SMTP_PASSWORD L"???"
#define SMTP_FROM L"???@???"
#define SMTP_TO L"???@???"

// POP3
#define POP3_HOST L"???"
#define POP3_PORT 110
#define POP3_USER L"???"
#define POP3_PASSWORD L"???"

//============================================================
// HTTP

// _E[h
bool HTTPDownload(String^ uri, String^ localfile) {
	try {
		WebClient^ client=gcnew WebClient();
		client->DownloadFile(uri, localfile);
		return true;
	} catch (SystemException^) {
		MessageBox::Show("URIJ܂");
	}
	return false;
}

// _E[hiWin32j
bool HTTPDownloadWin32(WCHAR* uri, WCHAR* localfile) {
	HINTERNET inet;
	inet=InternetOpen(L"VCTest", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if (!inet) {
		::MessageBox(0, L"Cuł܂", L"", MB_OK);
		return false;
	}
	
	HINTERNET session;
	session=InternetOpenUrl(inet, uri, NULL, 0, INTERNET_FLAG_RELOAD, 0);
	if (!session) {
		InternetCloseHandle(inet);
		::MessageBox(0, L"URIɐڑł܂", L"", MB_OK);
		return false;
	}

	HANDLE file=CreateFile(
		localfile, GENERIC_WRITE, 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (file==INVALID_HANDLE_VALUE) {	
		InternetCloseHandle(session);
		InternetCloseHandle(inet);
		::MessageBox(0, L"t@C쐬ł܂", L"", MB_OK);
		return false;
	}

	DWORD read_bytes;
	DWORD write_bytes;
	char buf[1000];
	do {
		if (
			!InternetReadFile(session, buf, sizeof(buf), &read_bytes) ||
			!WriteFile(file, buf, read_bytes, &write_bytes, NULL)
		) {
			InternetCloseHandle(session);
			InternetCloseHandle(inet);
			CloseHandle(file);
			::MessageBox(0, L"]Ɏs܂", L"", MB_OK);
			return false;
		} 
	} while (read_bytes>0);
	
	InternetCloseHandle(session);
	InternetCloseHandle(inet);
	CloseHandle(file);
	return true;
}

// _E[h̃eXg
void TestHttpDownload() {
	if (HTTPDownload(HTTP_URI, "download.txt")) {
		MessageBox::Show("_E[hɐ܂");
	}
}

// _E[h̃eXgiWin32j
void TestHttpDownloadWin32() {
	if (HTTPDownloadWin32(HTTP_URI, L"download.txt")) {
		::MessageBox(0, L"_E[hɐ܂", L"", MB_OK);
	}
}

//============================================================
// FTP

// Abv[h
bool FtpUpload(String^ user, String^ password, String^ uri, String^ localfile) {
	FileStream^ in;
	Stream^ out;
	try {
		WebRequest^ req=WebRequest::Create(uri);
		req->Credentials=gcnew NetworkCredential(user, password);
		req->Method=WebRequestMethods::Ftp::UploadFile;
		out=req->GetRequestStream();
		try {
			in=gcnew FileStream(localfile, FileMode::Open);
			try {
				array<unsigned char>^ buf=gcnew array<unsigned char>(1000);
				int count;
				while ((count=in->Read(buf, 0, buf->Length))>0) {
					out->Write(buf, 0, count);
				}
				return true;
			} catch (SystemException^) {
				MessageBox::Show("t@C̓]Ɏs܂");
			}
		} catch (SystemException^) {
			MessageBox::Show("[Jt@CJ܂");
		}
	} catch (SystemException^) {
		MessageBox::Show("ڑł܂");
	} finally {
		if (in) in->Close();
		if (out) out->Close();
	}
	return false;
}

// Abv[h̃eXg
void TestFtpUpload() {
	if (FtpUpload(FTP_USER, FTP_PASSWORD, FTP_URI, "upload.txt")) {
		MessageBox::Show("t@C̃Abv[hɐ܂");
	}
}

// _E[h
bool FtpDownload(String^ user, String^ password, String^ uri, String^ localfile) {
	WebResponse^ res;
	Stream^ in;
	FileStream^ out;
	try {
		WebRequest^ req=WebRequest::Create(uri);
		req->Credentials=gcnew NetworkCredential(user, password);
		req->Method=WebRequestMethods::Ftp::DownloadFile;
		res=req->GetResponse();
		in=res->GetResponseStream();
		try {
			out=gcnew FileStream(localfile, FileMode::Create);
			try {
				array<unsigned char>^ buf=gcnew array<unsigned char>(1000);
				int count;
				while ((count=in->Read(buf, 0, buf->Length))>0) {
					out->Write(buf, 0, count);
				}
				return true;
			} catch (SystemException^) {
				MessageBox::Show("t@C̓]Ɏs܂");
			}
		} catch (SystemException^) {
			MessageBox::Show("[Jt@CJ܂");
		}
	} catch (SystemException^) {
		MessageBox::Show("ڑł܂");
	} finally {
		if (in) in->Close();
		if (out) out->Close();
		if (res) res->Close();
	}
	return false;
}

// _E[h̃eXg
void TestFtpDownload() {
	if (FtpDownload(FTP_USER, FTP_PASSWORD, FTP_URI, "download.txt")) {
		MessageBox::Show("t@C̃_E[hɐ܂");
	}
}

// Abv[hE_E[hEr̃eXg
void TestFtpUploadDownloadCompare() {
	array<unsigned char>^ old_file;
	array<unsigned char>^ new_file;
	if (
		FtpUpload(FTP_USER, FTP_PASSWORD, FTP_URI, "upload.txt") &&
		FtpDownload(FTP_USER, FTP_PASSWORD, FTP_URI, "download.txt") &&
		(old_file=ReadBinaryFile("upload.txt")) &&
		(new_file=ReadBinaryFile("download.txt")) &&
		old_file->Length==new_file->Length
	) {
		int i;
		for (i=0; i<old_file->Length; i++) {
			if (old_file[i]!=new_file[i]) break;
		}
		if (i==old_file->Length) {
			MessageBox::Show("Abv[hE_E[hErɐ");
		} else {
			MessageBox::Show("Abv[hE_E[hErɎs");
		}
	}
}

//============================================================
// FTPiWin32j

// Abv[h
bool FtpUploadWin32(WCHAR* user, WCHAR* password, WCHAR* host, WCHAR* remotefile, WCHAR* localfile) {
	HINTERNET inet;
	inet=InternetOpen(L"VCTest", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	if (!inet) {
		::MessageBox(0, L"ڑł܂", L"", MB_OK);
		return false;
	}
	
	HINTERNET session;
	session=InternetConnect(
		inet, host, INTERNET_DEFAULT_FTP_PORT, user, password, 
		INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0);
	if (!session) {
		InternetCloseHandle(inet);
		::MessageBox(0, L"FTPT[oɐڑł܂", L"", MB_OK);
		return false;
	}
	
	bool result=FtpPutFile(session, localfile, remotefile, FTP_TRANSFER_TYPE_BINARY, 0)==TRUE;
	if (!result) {
		::MessageBox(0, L"]Ɏs܂", L"", MB_OK);
	}
	InternetCloseHandle(session);
	InternetCloseHandle(inet);

	return result;
}

// _E[h
bool FtpDownloadWin32(WCHAR* user, WCHAR* password, WCHAR* host, WCHAR* remotefile, WCHAR* localfile) {
	HINTERNET inet;
	inet=InternetOpen(L"VCTest", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	if (!inet) {
		::MessageBox(0, L"ڑł܂", L"", MB_OK);
		return false;
	}
	
	HINTERNET session;
	session=InternetConnect(
		inet, host, INTERNET_DEFAULT_FTP_PORT, user, password, 
		INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE, 0);
	if (!session) {
		InternetCloseHandle(inet);
		::MessageBox(0, L"FTPT[oɐڑł܂", L"", MB_OK);
		return false;
	}
	
	bool result=FtpGetFile(session, remotefile, localfile, FALSE, FILE_ATTRIBUTE_ARCHIVE, FTP_TRANSFER_TYPE_BINARY, 0)==TRUE;
	if (!result) {
		InternetCloseHandle(session);
		InternetCloseHandle(inet);
		::MessageBox(0, L"]Ɏs܂", L"", MB_OK);
		return false;
	}
	InternetCloseHandle(session);
	InternetCloseHandle(inet);

	return result;
}

// Abv[h̃eXg
void TestFtpUploadWin32() {
	if (FtpUploadWin32(FTP_USER, FTP_PASSWORD, FTP_HOST, L"test.txt", L"upload.txt")) {
		::MessageBox(0, L"t@C̃Abv[hɐ܂", L"", MB_OK);
	}
}

// _E[h̃eXg
void TestFtpDownloadWin32() {
	if (FtpDownloadWin32(FTP_USER, FTP_PASSWORD, FTP_HOST, L"test.txt", L"download.txt")) {
		::MessageBox(0, L"t@C̃_E[hɐ܂", L"", MB_OK);
	}
}

// Abv[hE_E[hEr̃eXg
void TestFtpUploadDownloadCompareWin32() {
	char* old_data;
	int old_size;
	char* new_data;
	int new_size;
	if (
		FtpUploadWin32(FTP_USER, FTP_PASSWORD, FTP_HOST, L"test.txt", L"upload.txt") &&
		FtpDownloadWin32(FTP_USER, FTP_PASSWORD, FTP_HOST, L"test.txt", L"download.txt") &&
		ReadBinaryFileWin32(L"upload.txt", &old_data, &old_size) &&
		ReadBinaryFileWin32(L"download.txt", &new_data, &new_size) &&
		old_size==new_size
	) {
		int i;
		for (i=0; i<old_size; i++) {
			if (old_data[i]!=new_data[i]) break;
		}
		if (i==old_size) {
			::MessageBox(0, L"Abv[hE_E[hErɐ", L"", MB_OK);
		} else {
			::MessageBox(0, L"Abv[hE_E[hErɎs", L"", MB_OK);
		}
	}
}

//============================================================
// [

// M
bool SendMail(String^ host, int port, String^ user, String^ password, String^ from, String^ to, String^ subject, String^ body) {
	try {
		SmtpClient^ client=gcnew SmtpClient();
		client->Host=host;
		client->Port=port;
		client->Credentials=gcnew NetworkCredential(user, password);
		client->Send(from, to, subject, body);
		return true;
	} catch (SmtpException^) {
		MessageBox::Show("SMTPT[oɐڑł܂");
	} catch (SystemException^) {
		MessageBox::Show("p[^sK؂ł");
	}
	return false;
}

// MeXg
void TestSendMail() {
	if (SendMail(SMTP_HOST, SMTP_PORT, SMTP_USER, SMTP_PASSWORD, SMTP_FROM, SMTP_TO, "Test Mail", "This is a test mail.")) {
		MessageBox::Show("[̑Mɐ܂");
	}
}

// MeXgi{j
void TestSendMailJapanese() {
	if (SendMail(SMTP_HOST, SMTP_PORT, SMTP_USER, SMTP_PASSWORD, SMTP_FROM, SMTP_TO, "eXg[", "̓eXg[łB")) {
		MessageBox::Show("[̑Mɐ܂");
	}
}

// MiWin32j
bool ReceiveMailWin32(WCHAR* host, int port, WCHAR* user, WCHAR* pass, WCHAR* localfile) {
	char mbhost[1000];
	mbhost[WideCharToMultiByte(932, 0, host, wcslen(host), mbhost, sizeof(mbhost), NULL, NULL)]='\0';
	char mbuser[1000];
	mbuser[WideCharToMultiByte(932, 0, user, wcslen(user), mbuser, sizeof(mbuser), NULL, NULL)]='\0';
	char mbpass[1000];
	mbpass[WideCharToMultiByte(932, 0, pass, wcslen(pass), mbpass, sizeof(mbpass), NULL, NULL)]='\0';

	char buf[1000];
	int len;

	WSADATA wsadata;
	WSAStartup(MAKEWORD(2,0), &wsadata);
	
	int sock=socket(AF_INET, SOCK_STREAM, 0);
	LPHOSTENT hostent=gethostbyname(mbhost);
	if (
		!hostent || hostent->h_addrtype!=AF_INET ||
		hostent->h_length!=4 || !hostent->h_addr_list[0]
	) {
		WSACleanup();
		::MessageBox(0, L"zXg܂", L"", MB_OK);
		return false;
	}
	
	sockaddr_in sa;
	ZeroMemory(&sa, sizeof(sa));
	sa.sin_family=AF_INET;
	sa.sin_addr.s_addr=*(unsigned long*)(hostent->h_addr_list[0]);
	sa.sin_port=htons(port);
	if (connect(sock, (struct sockaddr*)&sa, sizeof(sa))) {
		WSACleanup();
		::MessageBox(0, L"zXgɐڑł܂", L"", MB_OK);
		return false;
	}
			
	recv(sock, buf, sizeof(buf)-1, 0);
	sprintf(buf, "USER %s\n", mbuser);
	send(sock, buf, strlen(buf), 0);
	recv(sock, buf, sizeof(buf)-1, 0);
	sprintf(buf, "PASS %s\n", mbpass);
	send(sock, buf, strlen(buf), 0);
	recv(sock, buf, sizeof(buf)-1, 0);
	if (strncmp(buf, "+OK", 3)!=0) {
		closesocket(sock);
		WSACleanup();
		::MessageBox(0, L"OCɎs", L"", MB_OK);
		return false;
	}

	sprintf(buf, "STAT\n");
	send(sock, buf, strlen(buf), 0);
	len=recv(sock, buf, sizeof(buf)-1, 0);
	buf[len]='\0';
	if (strncmp(buf, "+OK", 3)!=0) {
		closesocket(sock);
		WSACleanup();
		::MessageBox(0, L"[̎擾Ɏs", L"", MB_OK);
		return false;
	}

	strtok(buf, " ");
	strtok(NULL, " ");
	char* p=buf;
	p+=strlen(p)+1;
	int count=atoi(p);

	HANDLE file=CreateFile(
		localfile, GENERIC_WRITE, 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (file==INVALID_HANDLE_VALUE) {	
		closesocket(sock);
		WSACleanup();
		::MessageBox(0, L"t@C쐬ł܂", L"", MB_OK);
		return false;
	}
	
	for (int i=1; i<=count; i++) {
		sprintf(buf, "RETR %d\n", i);
		send(sock, buf, strlen(buf), 0);
		bool first=true;
		do {
			len=recv(sock, buf, sizeof(buf)-1, 0);
			buf[len]='\0';
			DWORD nbytes;
			if (
				(first && strncmp(buf, "+OK", 3)!=0) ||
				!WriteFile(file, buf, len, &nbytes, NULL) || 
				len!=nbytes
			) {
				CloseHandle(file);
				closesocket(sock);
				WSACleanup();
				::MessageBox(0, L"[̎擾Ɏs", L"", MB_OK);
				return false;
			}
			first=false;
		} while (
			(len!=3 || strcmp(buf, ".\r\n")!=0) && 
			(len!=2 || strcmp(buf, ".\n")!=0) && 
			(len<5 || strcmp(buf+len-5, "\r\n.\r\n")!=0) && 
			(len<3 || strcmp(buf+len-3, "\n.\n")!=0)
		);
	}
	
	CloseHandle(file);
	closesocket(sock);
	WSACleanup();
	return true;
}

// MeXgiWin32j
void TestReceiveMailWin32() {
	if (ReceiveMailWin32(POP3_HOST, POP3_PORT, POP3_USER, POP3_PASSWORD, L"mail.txt")) {
		::MessageBox(0, L"[̎Mɐ܂", L"", MB_OK);
	}
}

// M
bool ReceiveMail(String^ host, int port, String^ user, String^ pass, String^ localfile) {
	pin_ptr<WCHAR>
		h=&host->ToCharArray()[0],
		u=&user->ToCharArray()[0],
		p=&pass->ToCharArray()[0],
		l=&localfile->ToCharArray()[0];
	return ReceiveMailWin32(h, port, u, p, l);
}

// MeXg
void TestReceiveMail() {
	if (ReceiveMail(POP3_HOST, POP3_PORT, POP3_USER, POP3_PASSWORD, L"mail.txt")) {
		::MessageBox(0, L"[̎Mɐ܂", L"", MB_OK);
	}
}
