#include "Common.h"

//============================================================
// 

// ̎擾
DateTime^ GetDateTime() {
	return DateTime::Now;
}

// 擾̃eXg
void TestGetDateTime() {
	MessageBox::Show(GetDateTime()->ToString());
}

// ̐`
String^ GetFormattedDateTime() {
	return GetDateTime()->ToString("yyyyNMdAHmsb");
}

// `̃eXg
void TestGetFormattedDateTime() {
	MessageBox::Show(GetFormattedDateTime());
}

// J_[̕\
void ShowCalendar(Graphics^ g) {
	Font^ font=gcnew Font("System", 12);
	Brush^ brush=gcnew SolidBrush(Color::Black);	

	DateTime^ now=GetDateTime();
	g->DrawString(now->ToString("yyyyNM̃J_["), font, brush, 0, 0);

	String^ dow="ΐ؋y";
	float size=30;
	for (int i=0; i<7; i++) {
		g->DrawString(dow->Substring(i, 1), font, brush, (float)i*size, size);
	}

	float x=(float)((gcnew DateTime(now->Year, now->Month, 1))->DayOfWeek);
	float y=0;

	int dim=DateTime::DaysInMonth(now->Year, now->Month);
	for (int day=1; day<=dim; day++) {
		g->DrawString(day.ToString(), font, brush, x*size, y*size+size*2);
		x++;
		if (x>=7) {
			x=0;
			y++;
		}
	}
}

//============================================================
// iWin32j

// ̎擾
void GetDateTimeWin32(SYSTEMTIME* st) {
	GetLocalTime(st);
}

// 擾̃eXg
void TestGetDateTimeWin32() {
	SYSTEMTIME st;
	GetDateTimeWin32(&st);
	WCHAR buf[1000];
	wsprintf(buf, L"%d/%d/%d %d:%d:%d", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
	::MessageBox(0, buf, L"", MB_OK);
}

// ̐`
void GetFormattedDateTimeWin32(WCHAR* buf, int size) {
	SYSTEMTIME st;
	GetLocalTime(&st);
	GetDateFormat(LOCALE_SYSTEM_DEFAULT, 0, &st, L"yyyyNMdA", buf, size);
	GetTimeFormat(LOCALE_SYSTEM_DEFAULT, 0, &st, L"Hmsb", buf+wcslen(buf), size-wcslen(buf));
}

// `̃eXg
void TestGetFormattedDateTimeWin32() {
	WCHAR buf[1000];
	GetFormattedDateTimeWin32(buf, sizeof(buf)/sizeof(WCHAR));
	::MessageBox(0, buf, L"", MB_OK);
}

//============================================================
// WXg

// ݒ
bool SetRegistry(String^ key_name, String^ name, String^ value) {
	try {
		RegistryKey^ key=Registry::CurrentUser->CreateSubKey(key_name);
		key->SetValue(name, value);
		key->Close();
		return true;
	} catch (ArgumentException^) {
		MessageBox::Show("L[sK؂ł");
	} catch (SystemException^) {
		MessageBox::Show("L[ɃANZXł܂");
	}
	return false;
}

// 擾
String^ GetRegistry(String^ key_name, String^ name) {
	try {
		RegistryKey^ key=Registry::CurrentUser->OpenSubKey(key_name);
		if (key) {
			String^ value=(String^)key->GetValue(name);
			key->Close();
			return value;
		}
	} catch (ArgumentException^) {
		MessageBox::Show("L[sK؂ł");
	} catch (SystemException^) {
		MessageBox::Show("L[ɃANZXł܂");
	}
	return nullptr;
}

// 폜
bool DeleteRegistry(String^ key_name) {
	try {
		Registry::CurrentUser->DeleteSubKey(key_name);
		return true;
	} catch (InvalidOperationException^) {
		MessageBox::Show("L[ɃTuL[邽ߍ폜ł܂");
	} catch (ArgumentException^) {
		MessageBox::Show("L[sK؂ł");
	} catch (SystemException^) {
		MessageBox::Show("L[ɃANZXł܂");
	}
	return false;
}

// ݒ̃eXg
void TestSetRegistry() {
	if (SetRegistry("Software\\test", "author", "Ђ؂H[")) {
		MessageBox::Show("WXg̐ݒɐ");
	}
}

// 擾̃eXg
void TestGetRegistry() {
	String^ value=GetRegistry("Software\\test", "author");
	if (value) MessageBox::Show(value, "WXg̎擾ɐ");
}

// 폜̃eXg
void TestDeleteRegistry() {
	if (DeleteRegistry("Software\\test")) {
		MessageBox::Show("WXg̍폜ɐ");
	}
}

// ݒE擾E폜̃eXg
void TestSetGetDeleteRegistry() {
	String^ key_name="Software\\test";
	String^ value;
	if (
		SetRegistry(key_name, "author", "Ђ؂H[") &&
		(value=GetRegistry(key_name, "author"))!=nullptr &&
		value->Equals("Ђ؂H[") &&
		DeleteRegistry(key_name) &&
		!GetRegistry(key_name, "author")
	) {
		MessageBox::Show("WXg̐ݒE擾E폜ɐ");
	} else {
		MessageBox::Show("WXg̐ݒE擾E폜Ɏs");
	}
}

//============================================================
// WXgiWin32j

// ݒ
bool SetRegistryWin32(WCHAR* key_name, WCHAR* name, WCHAR* value) {
	HKEY key;
	if (ERROR_SUCCESS!=RegCreateKeyEx(
		HKEY_CURRENT_USER, key_name, 0, NULL, 0,  
		KEY_SET_VALUE, NULL, &key, NULL)
	) {
		::MessageBox(0, L"L[쐬ł܂", L"", MB_OK);
		return false;
	}
	if (ERROR_SUCCESS!=RegSetValueEx(
		key, name, 0, REG_SZ, (const BYTE*)value, 
		(wcslen(value)+1)*sizeof(WCHAR))
	) {
		::MessageBox(0, L"lݒł܂", L"", MB_OK);
		RegCloseKey(key);
		return false;
	}
	RegCloseKey(key);
	return true;
}

// 擾
WCHAR* GetRegistryWin32(WCHAR* key_name, WCHAR* name) {
	HKEY key;
	if (ERROR_SUCCESS!=RegOpenKeyEx(
		HKEY_CURRENT_USER, key_name, 0, 
		KEY_QUERY_VALUE, &key)
	) {
		::MessageBox(0, L"L[J܂", L"", MB_OK);
		return NULL;
	}
	DWORD type, size;
	if (ERROR_SUCCESS!=RegQueryValueEx(
		key, name, NULL, &type, NULL, &size)
	) {
		::MessageBox(0, L"ľ^ƃTCY擾ł܂", L"", MB_OK);
		RegCloseKey(key);
		return NULL;
	}
	if (type!=REG_SZ) {
		::MessageBox(0, L"ľ^sK؂ł", L"", MB_OK);
		RegCloseKey(key);
		return NULL;
	}
	BYTE* buf=new BYTE[size];
	if (ERROR_SUCCESS!=RegQueryValueEx(
		key, name, NULL, NULL, buf, &size)
	) {
		::MessageBox(0, L"l擾ł܂", L"", MB_OK);
		RegCloseKey(key);
		return NULL;
	}
	RegCloseKey(key);
	return (WCHAR*)buf;
}

// 폜
bool DeleteRegistryWin32(WCHAR* key_name) {
	if (ERROR_SUCCESS!=RegDeleteKey(
		HKEY_CURRENT_USER, key_name)
	) {
		::MessageBox(0, L"L[폜ł܂", L"", MB_OK);
		return false;
	}
	return true;
}

// ݒ̃eXg
void TestSetRegistryWin32() {
	if (SetRegistryWin32(L"Software\\test", L"author", L"Ђ؂H[")) {
		::MessageBox(0, L"WXg̐ݒɐ", L"", MB_OK);
	}
}

// 擾̃eXg
void TestGetRegistryWin32() {
	WCHAR* value=GetRegistryWin32(L"Software\\test", L"author");
	if (value) ::MessageBox(0, value, L"WXg̎擾ɐ", MB_OK);
}

// 폜̃eXg
void TestDeleteRegistryWin32() {
	if (DeleteRegistryWin32(L"Software\\test")) {
		::MessageBox(0, L"WXg̍폜ɐ", L"", MB_OK);
	}
}

// ݒE擾E폜̃eXg
void TestSetGetDeleteRegistryWin32() {
	WCHAR* key_name=L"Software\\test";
	WCHAR* value;
	if (
		SetRegistryWin32(key_name, L"author", L"Ђ؂H[") &&
		(value=GetRegistryWin32(key_name, L"author"))!=NULL &&
		wcscmp(value, L"Ђ؂H[")==0 &&
		DeleteRegistryWin32(key_name) &&
		!GetRegistryWin32(key_name, L"author")
	) {
		::MessageBox(0, L"WXg̐ݒE擾E폜ɐ", L"", MB_OK);
	} else {
		::MessageBox(0, L"WXg̐ݒE擾E폜Ɏs", L"", MB_OK);
	}
}

//============================================================
// gq̓o^

// gq̓o^iWin32j
bool RegisterExtensionWin32(WCHAR* extension, WCHAR* instruction, WCHAR* command, bool overwrite) {
	HKEY key;
	DWORD disp;
	
	WCHAR class_name[100];
	swprintf_s(class_name, sizeof(class_name)/sizeof(WCHAR), L"%s_auto_file", extension);
	
	// gq̓o^
	WCHAR ext_key[100];
	swprintf_s(ext_key, sizeof(ext_key)/sizeof(WCHAR), L".%s", extension);
	
	if (ERROR_SUCCESS!=RegCreateKeyEx(
		HKEY_CLASSES_ROOT, ext_key, NULL, L"", 
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 
		NULL, &key, &disp)
	) {
		::MessageBox(0, L"gq̓o^Ɏs܂", L"", MB_OK);
		return false;
	}
	if (!overwrite && disp==REG_OPENED_EXISTING_KEY) {
		RegCloseKey(key);
		::MessageBox(0, L"ɓo^Ăgqł", L"", MB_OK);
		return false;
	}
	RegSetValueEx(key, NULL, 0, REG_SZ, (BYTE*)class_name, (wcslen(class_name)+1)*2);
	RegCloseKey(key);

	// ̓o^
	if (ERROR_SUCCESS!=RegCreateKeyEx(
		HKEY_CLASSES_ROOT, class_name, NULL, L"", 
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 
		NULL, &key, &disp)
	) {
		::MessageBox(0, L"̓o^Ɏs܂", L"", MB_OK);
		return false;
	}
	RegSetValueEx(key, NULL, 0, REG_SZ, (BYTE*)instruction, (wcslen(instruction)+1)*2);
	RegCloseKey(key);

	// R}h̓o^
	WCHAR command_key[100];
	swprintf_s(command_key, sizeof(command_key)/sizeof(WCHAR), L"%s\\shell\\open\\command", class_name);
	
	WCHAR command_value[100];
	swprintf_s(command_value, sizeof(command_value)/sizeof(WCHAR), L"\"%s\" %%1", command);
	
	if (ERROR_SUCCESS!=RegCreateKeyEx(
		HKEY_CLASSES_ROOT, command_key, NULL, L"", 
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 
		NULL, &key, &disp)
	) {
		::MessageBox(0, L"R}h̓o^Ɏs܂", L"", MB_OK);
		return false;
	}
	RegSetValueEx(key, NULL, 0, REG_SZ, (BYTE*)command_value, (wcslen(command_value)+1)*2);
	RegCloseKey(key);

	// ACR̓o^
	WCHAR icon_key[100];
	swprintf_s(icon_key, sizeof(icon_key)/sizeof(WCHAR), L"%s\\DefaultIcon", class_name);
	
	WCHAR icon_value[100];
	swprintf_s(icon_value, sizeof(icon_value)/sizeof(WCHAR), L"%s,0", command);
	
	if (ERROR_SUCCESS!=RegCreateKeyEx(
		HKEY_CLASSES_ROOT, icon_key, NULL, L"", 
		REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 
		NULL, &key, &disp)
	) {
		::MessageBox(0, L"ACR̓o^Ɏs܂", L"", MB_OK);
		return false;
	}
	RegSetValueEx(key, NULL, 0, REG_SZ, (BYTE*)icon_value, (wcslen(icon_value)+1)*2);
	RegCloseKey(key);

	return true;
}

// gq̓o^
bool RegisterExtension(String^ extension, String^ instruction, String^ command, bool overwrite) {
	pin_ptr<WCHAR> 
		ext=&extension->ToCharArray()[0],
		inst=&instruction->ToCharArray()[0],
		cmd=&command->ToCharArray()[0];
	return RegisterExtensionWin32(ext, inst, cmd, overwrite);
}

// gqo^̃eXgiWin32j
void TestRegisterExtensionWin32() {
	if (RegisterExtensionWin32(L"test", L"gqo^̃eXg", L"C:\\Windows\\notepad.exe", true)) {
		::MessageBox(0, L"gq̓o^ɐ܂", L"", MB_OK);
	}
}

// gqo^̃eXg
void TestRegisterExtension() {
	if (RegisterExtension("test", "gqo^̃eXg", "C:\\Program Files\\Internet Explorer\\iexplore.exe", true)) {
		MessageBox::Show("gq̓o^ɐ܂");
	}
}

//============================================================
// Vbg_E

bool EnablePrivileges() {
	HANDLE token;
	TOKEN_PRIVILEGES tp;
	tp.PrivilegeCount=1;
	tp.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED;
	if (
		OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, &token) &&
		LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME, &tp.Privileges[0].Luid) &&
		AdjustTokenPrivileges(token, FALSE, &tp, 0, NULL, NULL)
	) {
		return true;
	}
	::MessageBox(0, L"Vbg_Ě擾ł܂", L"", MB_OK);
	return false;
}

// Vbg_E
bool Shutdown() {
	if (!EnablePrivileges()) return false;
	if (ExitWindowsEx(EWX_POWEROFF|EWX_FORCEIFHUNG, SHTDN_REASON_MINOR_MAINTENANCE)) return true;
	::MessageBox(0, L"Vbg_EɎs܂", L"", MB_OK);
	return false;
}

// ċN
bool Reboot() {
	if (!EnablePrivileges()) return false;
	if (ExitWindowsEx(EWX_REBOOT|EWX_FORCEIFHUNG, SHTDN_REASON_MINOR_MAINTENANCE)) return true;
	::MessageBox(0, L"ċNɎs܂", L"", MB_OK);
	return false;
}

// OIt
bool Logoff() {
	if (ExitWindowsEx(EWX_LOGOFF|EWX_FORCEIFHUNG, SHTDN_REASON_MINOR_MAINTENANCE)) return true;
	::MessageBox(0, L"OItɎs܂", L"", MB_OK);
	return false;
}

//============================================================
// AvP[V̋N

// N
bool RunApplication(String^ file, bool wait) {
	try {
		Process^ p=Process::Start(file);
		if (wait) p->WaitForExit();
		return true;
	} catch (Win32Exception^) {
		MessageBox::Show("֘AÂꂽAvP[VJ܂");
	} catch (ObjectDisposedException^) {
		MessageBox::Show("vZX͊ɔjĂ܂");
	} catch (FileNotFoundException^) {
		MessageBox::Show("t@C܂");
	} catch (SystemException^) {
		MessageBox::Show("vZXҋ@ł܂");
	}
	return false;
}

// NiWin32j
bool RunApplicationWin32(WCHAR* file, bool wait) {
	SHELLEXECUTEINFO sei;
	ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));
	sei.cbSize=sizeof(SHELLEXECUTEINFO);
	sei.lpVerb=L"open";
	sei.lpFile=file;
	sei.fMask=SEE_MASK_NOCLOSEPROCESS;
	sei.nShow=SW_SHOWNORMAL;
	if (!ShellExecuteEx(&sei)) {
		::MessageBox(0, L"AvP[V̋NɎs", L"", MB_OK);
		return false;
	}
	if (wait && WaitForSingleObject(sei.hProcess, INFINITE)==WAIT_FAILED) {
		::MessageBox(0, L"Ȋҋ@Ɏs", L"", MB_OK);
		CloseHandle(sei.hProcess);
		return false;
	}
	CloseHandle(sei.hProcess);
	return true;
}

// ÑeXg
void TestRunApplication() {
	RunApplication("C:\\Windows\\notepad.exe", true);
}

// ֘AAvP[V̋NeXg
void TestRunAssociatedApplication() {
	RunApplication("test.bmp", false);
}

// ÑeXgiWin32j
void TestRunApplicationWin32() {
	RunApplicationWin32(L"C:\\Windows\\notepad.exe", true);
}

// ֘AAvP[V̋NeXgiWin32j
void TestRunAssociatedApplicationWin32() {
	RunApplicationWin32(L"test.bmp", false);
}

//============================================================
// OS̃o[W

// o[W̎擾
String^ GetSystemVersion() {
	Version^ ver=Environment::OSVersion->Version;
	String^ result="";
	result+="Version "+ver->Major+"."+ver->Minor+" ";
	result+="Build "+ver->Build+"\n";
	result+="("+Environment::OSVersion->VersionString+")";
	return result;
}

// o[W̎擾iWin32j
WCHAR* GetSystemVersionWin32() {
	OSVERSIONINFO vi;
	vi.dwOSVersionInfoSize=sizeof(vi);
	if (!GetVersionEx(&vi)) {
		::MessageBox(0, L"o[W̎擾Ɏs", L"", MB_OK);
		return NULL;
	}
	WCHAR* result=new WCHAR[1000];
	swprintf_s(result, 1000, L"Version %d.%d Build %d %s", vi.dwMajorVersion, vi.dwMinorVersion, vi.dwBuildNumber, vi.szCSDVersion);
	return result;	
}

// o[W擾̃eXg
void TestGetSystemVersion() {
	String^ ver=GetSystemVersion();
	if (ver) MessageBox::Show(ver);
}

// o[W擾̃eXgiWin32j
void TestGetSystemVersionWin32() {
	WCHAR* ver=GetSystemVersionWin32();
	if (ver) {
		::MessageBox(0, ver, L"", MB_OK);
		delete[] ver;
	}
}

//============================================================
// vZbT

// vZbT̎擾iWin32j
WCHAR* GetProcessorInfoWin32() {
	SYSTEM_INFO si;
	GetSystemInfo(&si);
	WCHAR* result=new WCHAR[1000];
	swprintf_s(result, 1000, 
		L"vZbT^Cv : %d\nvZbT : %d\ny[WTCY : %d\n", 
		si.dwProcessorType, si.dwNumberOfProcessors, si.dwPageSize); 
	return result;
}

// vZbT̎擾
String^ GetProcessorInfo() {
	WCHAR* info=GetProcessorInfoWin32();
	String^ s=gcnew String(info);
	delete[] info;
	return s;
}

// vZbT擾̃eXgiWin32j
void TestGetProcessorInfoWin32() {
	WCHAR* info=GetProcessorInfoWin32();
	::MessageBox(0, info, L"", MB_OK);
	delete[] info;
}

// vZbT擾̃eXg
void TestGetProcessorInfo() {
	MessageBox::Show(GetProcessorInfo());
}

//============================================================
// 

// 擾iWin32j
WCHAR* GetMemoryInfoWin32() {
	MEMORYSTATUS ms;
	GlobalMemoryStatus(&ms);
	WCHAR* result=new WCHAR[1000];
	swprintf_s(result, 1000, 
		L"Se : %d\n󂫗e : %d\n"
		L"zSe : %d\nz󂫗e : %d\n",
		ms.dwTotalPhys, ms.dwAvailPhys,
		ms.dwTotalVirtual, ms.dwAvailVirtual);
	return result;
}

// 擾
String^ GetMemoryInfo() {
	WCHAR* info=GetMemoryInfoWin32();
	String^ s=gcnew String(info);
	delete[] info;
	return s;
}

// 擾̃eXgiWin32j
void TestGetMemoryInfoWin32() {
	WCHAR* info=GetMemoryInfoWin32();
	::MessageBox(0, info, L"", MB_OK);
	delete[] info;
}

// 擾̃eXg
void TestGetMemoryInfo() {
	MessageBox::Show(GetMemoryInfo());
}

//============================================================
// y

// Đ
void PlayMedia(String^ file) {
	WindowsMediaPlayer^ wmp=gcnew WindowsMediaPlayer();
	wmp->URL=file;
	wmp->controls->play();
	MessageBox::Show("_CAOƍĐ~܂");
	wmp->controls->stop();
}

// Đ̃eXgiWAVEj
void TestPlayMediaWave() {
	PlayMedia("C:\\Windows\\Media\\notify.wav");
}

// Đ̃eXgiMIDIj
void TestPlayMediaMidi() {
	PlayMedia("C:\\Windows\\Media\\town.mid");
}

//============================================================
// Xbh

// Xbhōs
void ThreadWork() {
	try {
		for (int i=0; i<1000000000; i++) ;
		MessageBox::Show("Xbh̏܂");
	} catch (ThreadAbortException^) {
		MessageBox::Show("Xbh̏f܂");
	}
}

// Xbh̍쐬
Thread^ CreateThread() {
	Thread^ thread=gcnew Thread(gcnew ThreadStart(ThreadWork));
	thread->Start();
	return thread;
}

// Xbh̍쐬Ƒҋ@
void TestCreateJoinThread() {
	Thread^ thread=CreateThread();
	MessageBox::Show("Xbh̏҂킹܂");
	thread->Join();
}

// Xbh̍쐬ƒf
void TestCreateAbortThread() {
	Thread^ thread=CreateThread();
	MessageBox::Show("Xbh̏𒆒f܂");
	thread->Abort();
}

